// File: alarm.cc
//
// Time-stamp: <01-Jun-2003 20:53:25 goetz>
// $Id: $
//
// Copyright (C) 2003 by Rdiger Goetz
//
// Author: me
//
// Description: 
// 
//

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <linux/kd.h>
#include <errno.h>

#include "calendrian.h"
//#include <Fl/Fl.H>
//#include <flpda/tunes.h>

//Fl_App_Window *alarmWindow=NULL;
Fl_Window *alarmWindow=NULL;
FILE *fpt = NULL;

const char * alarmScript = "/tmp/calendrian.alarms.sh";
static char alarmLogFile[256];
static int alarmWindowClosed=0;


int displayAlarm(int now );
void updateAndStartAtJob();
void startAtJob();
void atJobCleaner();
void alarmSound(void *d );
void alarmSound(int *testt, int alarm_volume, int sec, int repeat);

#define DENUG_ALARM


typedef struct 
{
 int id;
 char *tim;
} AtJob;

class AtJobList
{
public:
 AtJob *job;
 int anz;
 int max;

 AtJobList()
 {
  anz=max=0;
  job=NULL;
 }
 ~AtJobList()
 {
  if(job != NULL)
   delete [] job;
 }

 void extend(int size)
 {
  AtJob *tmp;

  if(size > max)
   {
    tmp = new AtJob [ size];
    if(max>0)
     {
      memcpy(tmp,job,sizeof(AtJob)*max);
      delete [] job;
     }
    job =tmp;
    max= size;
   }
 }
 void add(int id,char *t)
 {
  if(anz >=max)
   extend(max +32);

  job[anz].id =id;
  int l =strlen(t);
  job[anz].tim = new char [l+1];
  strncpy(job[anz].tim,t,l);
  job[anz].tim[l] ='\0';
  anz++;
 }

 int find(int id)
 {
  for(int i=0;i<anz; i++)
   if(job[i].id == id)
    return i;

  return -1;
 }
 
 void setInvalid(int id)
 {
  int p=find(id);
  if( p>=0)
   invalid(p);
 }
 void invalid(int p)
 {
  if(job[p].tim != NULL)
   delete [] job[p].tim;
  job[p].tim = NULL;
 }

 void sort()
 {
  qsort(job,anz,sizeof(AtJob),AtJobList::compare);
 }
 static int compare(const void *v1,const void *v2)
 {
  AtJob *a1 = (AtJob *) v1;
  AtJob *a2 = (AtJob *) v2;

  if(a1->tim == NULL && a2->tim == NULL )
   return 0;
  if(a1->tim == NULL)
   return 1;
  if(a2->tim == NULL )
   return -1;

  return(strcmp(a1->tim,a2->tim));
 }
 
};


void acknowledgeAlarm(Fl_Widget *w)
{
 int tim=time(NULL);
 
 printf("ACK\n");
#ifdef DENUG_ALARM
 if(fpt != NULL)
  fprintf(fpt,"ACK %d\n",time(NULL));
#endif
 
 if(alarmWindow != NULL)
  {
#ifdef DENUG_ALARM
   if(fpt != NULL) 
    fprintf(fpt,"Alarm stopped %d\n",time(NULL));
#endif
   alarmWindowClosed=1;
   alarmWindow->hide();
#ifdef DENUG_ALARM
   if(fpt != NULL)
    fprintf(fpt,"Alarm window hidden %d\n",time(NULL));
#endif

   delete alarmWindow;
   alarmWindow = NULL;
#ifdef DENUG_ALARM
   if(fpt != NULL)
    fprintf(fpt,"Alarm window deleted %d\n",time(NULL));
#endif

   alarms.sort();
#ifdef DENUG_ALARM
   if(fpt != NULL)
    fprintf(fpt,"Alarms resorted %d\n",time(NULL));
#endif

   int now = time(NULL);
   if(displayAlarm (now) ==0)
    {
#ifdef DENUG_ALARM
     if(fpt != NULL)
      fprintf(fpt,"done at %d\n",time(NULL));
#endif
     exit(0);
    }
  }
}


void updateAndStartAtJob()
{
 Fl::check();
 readDB("./schedule.dat");
 Fl::check();
 cal.updateAlarm();
 Fl::check();
 rereadAlarmDB();
 Fl::check();
 startAtJob();
 Fl::check();
}

void  startAtJob()
{
 char cmd[256],tmp[64];
 struct tm *lt;
 FILE *fp;

 checkAlarmDB();
 alarms.count=0;
 readAlarmDB();
 alarms.sort();
 
 if(alarms.count>0)
  {
   fp =fopen(alarmScript,"w");
   fprintf(fp,"DISPLAY=:0 %s -alarm\n",progPath);
   //   fprintf(fp,"DISPLAY=:0 %s -alarm >>/tmp/cal.log\n",progPath);
   fprintf(fp,"# CalendrianAlarmer\n");
   fclose(fp);
   chmod(alarmScript,0755);
   int uid =getuid();
   if( uid != geteuid())
    chown(alarmScript,uid,getgid());



   
   lt = localtime(&alarms.ent[0].time);
   strftime(tmp,63,"%H:%M %d.%m.%y",lt);
   sprintf(cmd,"/usr/bin/at -f %s %s\n",alarmScript,tmp);
   //   printf(cmd);
   system(cmd);
   //   atJobCleaner();

  }

}

void atJobCleaner()
{
 FILE *pipe;
 char *key="CalendrianAlarmer";
 AtJobList list;
 char line[1024];
 int id;
 char date[64],timeStr[64],datetime[128],refStr[128],status[64];

 time_t tim = time(NULL);
 struct tm  * lt = localtime(&tim);
 strftime(refStr,63," %Y-%m-%d %H:%M",lt);
 // printf("atJobCleaner:\n");

//  system("/usr/bin/at -l");
//  printf("---\n");

 pipe = popen("/usr/bin/at -l","r");
 
 while( fgets(line,1023,pipe) != NULL)
  {
   sscanf(line,"%d %s %s %s\n",&id,date,timeStr,status);
   strcpy(datetime,date);
   strcat(datetime," ");
   strcat(datetime,timeStr);
   //   printf("status='%s'\n",status);
   if(status[0] == 'a')
    {
     //     printf("\t add job %d\n",id);
     list.add(id,datetime);
    }
  }
 pclose(pipe);

 for(int i=0; i<list.anz; i++)
  {
   int valid=false;

   sprintf(line,"/usr/bin/at -c %d",list.job[i].id);
   pipe = popen(line,"r");
   //   printf("CHECK: %s\n",line);
   while( fgets(line,1023,pipe) != NULL)
    {
     //     printf("JOB %d: %p <- '%s'\n",list.job[i].id,strstr(line,key),line);
     if(strstr(line,key)!= NULL)
      {
       valid=true;
       break;
      }
    }
   if(!valid)
    {
     list.invalid(i);
    }
  }
 

 list.sort();
 for(int i=0; i<list.anz; i++)
  {
   //   printf("job %3d at %s\n",list.job[i].id,list.job[i].tim);
  }
 printf("\n");
 for(int i=1; i<list.anz; i++)
  {
   //   printf("check %d: %p\n",i,list.job[i].tim);
   if(list.job[i].tim != NULL)
    {
     sprintf(line,"/usr/bin/at -d %d",list.job[i].id);
     system(line);
     //     printf("job %d removed\n",list.job[i].id);
    }
  }
}
int doAlarm();

int testAlarm()
{
 doAlarm();
}
int doAlarm()
{
 char txt[63];
 int count;

 sleep(2);
 int now = time(NULL);
#ifdef DENUG_ALARM
 struct tm *lt = localtime((const time_t*) &now);
 strftime(txt,63,"%d.%b %H:%M",lt);
 sprintf(alarmLogFile,"%s/testAlarm.log",getenv("HOME"));
 fpt = fopen(alarmLogFile,"w");

  fprintf(fpt,"testAlarm: release 12\n");
#endif

 checkAlarmDB();
 readAlarmDB();
 alarms.sort();

 count  = displayAlarm(now) ;
#ifdef DENUG_ALARM
 fprintf(fpt,"window with %d alarms\n",count);
#endif

 sleep(5);
 if(count>0)
  return Fl::run();
 return 0;
}


int displayAlarm(int now )
{
 int count =0;
 Appointment app;


 alarms.sort();

 if(alarms.count >0)
  {
   for(int i=0;i < alarms.count; i++)
    {
     //     printf("%d : %d vs %d  d=%d\n",i,alarms.ent[i].time , now,alarms.ent[i].time - now);
     if( alarms.ent[i].time <= now)
      count++;
    }
  }

#ifdef DENUG_ALARM
 if(fpt != NULL)
  {
   fprintf(fpt,"found %d current alarms @%d\n",count,time(NULL));
   fflush(fpt);
  }
#endif
 printf("found %d current alarms @%d\n",count,time(NULL));

 
 if(count >0)
  {
   alarmWindow =  new Fl_Window(0,0,160,240,"Alarm");
   alarmWindow->begin();
   alarmWindowClosed =0;

   Fl_Box *bg =  new Fl_Box(0,0,160,220);

   Fl_Box *head;
   if(count >1)
    head =  new Fl_Box(2,2,156,16,"You have some appointments:\n");
   else
    head =  new Fl_Box(2,2,156,16,"You have an appointments:\n");
   head->labelsize(10);
   int y=20;
   
   for(int i=0;i < alarms.count; i++)
    {
     char *txt;
     struct tm * lt;
     
//      if(i<8)
//       printf("%2d:check Alarm: atim=%10d now=%10d key=%08X\n",i,alarms.ent[i].time,now,alarms.ent[i].DBkey);

     if( alarms.ent[i].time <= now)
      {
       readFromDB(alarms.ent[i].DBkey, &app);       
//        printf("%2d: show Alarm at %10d before now =%10d on key %08X\n\t\t\t%s @ %10d\n",i,alarms.ent[i].time,now,alarms.ent[i].DBkey,app.title,app.start);

       Fl_Box * border = new Fl_Box( 2,y,156,40);
       border->box(FL_EMBOSSED_BOX);
       border->color(FL_WHITE);
 
       txt = new char [64];
       lt = localtime((const time_t*) &alarms.ent[i].time);
       strftime(txt,63,"On %d.%b %H:%M:  Alarm for",lt);
       Fl_Box *line1  = new Fl_Box(4,y+2,152,12,txt);
       line1->labelsize(10);
       line1->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

       txt = new char [64];
       strncpy(txt,app.title,63);
       txt[63]='\0';
       Fl_Box *line2  = new Fl_Box(4,y+14,152,12,txt);
       line2->labelsize(10);
       line2->align(FL_ALIGN_CENTER| FL_ALIGN_INSIDE);

       txt = new char [64];
       lt = localtime((const time_t*) &app.start);
       strftime(txt,63,"starting at %d.%b.%Y  %H:%M",lt);
       Fl_Box *line3  = new Fl_Box(4,y+26,152,12,txt);
       line3->labelsize(10);
       line3->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
       
       alarms.ent[i].time = 0x7FFFFFFF;
       y+= 38;
      }
    }
   Fl_Button *done = new Fl_Button(0,226,160,16,"Acknowledge");
   done->labelsize(10);
   done->callback(acknowledgeAlarm);
   alarmWindow->end();
   alarmWindow->show();
   Fl::add_timeout(2.0, alarmSound);
   //   alarmSound(&alarmWindowClosed,3, alarmRepeatIntervall, alarmRepeat);
  }
 else
  {
   Fl::check();
#ifdef DENUG_ALARM
   if(fpt != NULL)
    {
     fprintf(fpt,"update and restart at job @ %d \n",time(NULL));
     fflush(fpt);
    }
#endif
   updateAndStartAtJob();
#ifdef DENUG_ALARM
   if(fpt != NULL)
    {
     fprintf(fpt,"update and restart at job done @ %d \n",time(NULL));
     fflush(fpt);
    }
#endif
  }
 return count;
}


void updateAlarmRepeatAppointment(Appointment *app,int now)
{
 AppointmentInstance ai;
 time_t atim[4];
 int done=0;
 int end=0x7FFFFFFF;
 int hasAlarm=false;

 if(!app->canceled)
  {
   for(int a=0;a<4 ;a++)
    if(app->alarm[a]<0)
     {
      atim[a]=0;
      done++;
     }
   
   hasAlarm=false;
   ai.set(app);
   if(ai.setFirstAfter(now,end))
    {
     do
      {
       for(int a=0;a<4 ;a++)
	if(app->alarm[a]>0)
	 {
	  int tim = ai.start - app->alarm[a] *60;
	  //	  printf("\trep App %s start=%10d alarm%1d=%8d -> atim%1d=%10d > now=%10d\n",app->title,ai.start,a,app->alarm[a],a,tim,now);
	  if(tim>now)
	   {
	    atim[a] = tim;
	    hasAlarm=true;
	    done++;
	   }
	 }
       if(done>=4)
	break;
      }while(!ai.setNextBefore(now));
     if(hasAlarm)
      {
       //       printf("update rep app alarm: key=%08X atim=% 10d %10d ..\n",app->DBkey,atim[0],atim[1]);
       writeAlarmItem2DB(app->DBkey,atim);
      }
    }
  }
}

void alarmSound(void *d)
{
 while (! alarmWindow->shown() || ! alarmWindow->visible_r())
  {
   Fl::check();
   sleep(1);
  }
 alarmSound(&alarmWindowClosed,3, alarmRepeatIntervall, alarmRepeat);
}
int note(int fd, char n, int volume,int len, int *testt) 
{
 int value = 1193180;
 int var;

 if(volume == 1) 
  var = 5000;
 else if(volume == 2) 
  var = 2500;
 else 
  var = 0;
 
 switch(n) {
 case 'C' :
  return (value / 523) + var;
 case 'D':
  return (value / 587) + var;
 case 'E':
  return (value / 659) + var;
 case 'F':
  return (value / 698) + var;
 case 'G':
  return (value / 784) + var;
 case 'A':
  return (value / 880) + var;
 case 'B':
  return (value / 988) + var;
 case 'c' :
  return (value /1046) + var;
 default:
  return (value / 1046) + var;
 }


 ioctl(fd, KIOCSOUND, value);
 usleep(len);
 ioctl(fd, KIOCSOUND, 0);

 if(*testt == 1) return 0;
 return 1;
}
void alarmSound(int *testt, int alarm_volume, int sec, int repeat)
{
 if(alarm_volume == 0) return;

 int fd = open("/dev/console", O_RDWR);

#ifdef DENUG_ALARM
 if(fpt != NULL)
  fprintf(fpt,"Alarmsoud : %d\n",fd);
#endif

 if(fd < 0) 
  {
   printf("poor amns alarm\n");
   FILE *fp = fopen("/dev/tty9","w");

   for(int i = 0; i < repeat + 1; i++) 
    {
     for(int j=0; j<10 ; j++)
      {
       if(fp != NULL)
	{
	 putc('\a',fp);
	 fflush(fp);
	}
       else
	{
	 putchar('\a');
	 fflush(stdout);
	}
       usleep(250000);
      }
     Fl::check(); 
     if(*testt == 1) 
      break;
     for(int s = 0; s < sec; s++)
      {
       Fl::check(); 
       if(*testt == 1) 
	break;
       sleep(1);
      }
    }
   if(fp != NULL)
    fclose(fp);
  }
 else
  {
   for(int i = 0; i < repeat + 1; i++) 
    {
     for(int j=0;j<4; j++)
      {
       if(!note(fd,  'C', alarm_volume, 100000, testt)) 
	break;
       if(!note(fd,  'F', alarm_volume, 690000, testt)) 
	break;
       usleep(10000);
       if(!note(fd,  'F', alarm_volume, 100000, testt)) 
	break;
       if(!note(fd,  'A', alarm_volume, 690000, testt)) 
	break;
       usleep(10000);
       if(!note(fd,  'A', alarm_volume, 100000, testt)) 
	break;
       if(!note(fd,  'c', alarm_volume, 700000, testt)) 
	break;
       if(!note(fd,  'A', alarm_volume, 800000, testt)) 
	break;
       usleep(800000);
      }
     Fl::check(); 
     if(*testt == 1) 
      break;
     for(int s = 0; s < sec; s++)
      {
       Fl::check(); 
       if(*testt == 1) 
	break;
       sleep(1);
      }	
    }
   close(fd);
  }
}

