// File: dayCal.cc
//
// Time-stamp: <12-May-2003 22:56:39 goetz>
// $Id: $
//
// Copyright (C) 2003 by Rdiger Goetz
//
// Author: me
//
// Description: 
// 
//

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <unistd.h>

#include "calendrian.h"
#include <flpda/Fl_Paged_Scroll.H>
// #include "acal_gui.h"
// #include "appointment.h"
// #include "calTimeLine.h"

extern Calendar cal;
extern int kernStart, kernEnd;

static Fl_Button *dayCalYearPlus, *dayCalMonPlus, *dayCalWeekPlus, *dayCalDayPlus,**dayCalLines;
static Fl_Button *dayCalYearMinus, *dayCalMonMinus, *dayCalWeekMinus, *dayCalDayMinus,**dayCalApp;
static Fl_Box    *dayCalHead,**dayCalAppBox;
static calTimeLineList tl;

void dayCalPlusYear(Fl_Widget *w);
void dayCalPlusMon(Fl_Widget *w);
void dayCalPlusWeek(Fl_Widget *w);
void dayCalPlusDay(Fl_Widget *w);
void dayCalMinusYear(Fl_Widget *w);
void dayCalMinusMon(Fl_Widget *w);
void dayCalMinusWeek(Fl_Widget *w);
void dayCalMinusDay(Fl_Widget *w);




void drawDayCalWindow()
{
 AppointmentInstanceList *sel;
 timeDef t0,t1;
 // int from,to;
 static char tx[64];
 int begin,end;
 int *timeLine,timeLines,timeLines0;
 int *start,*stop;
 int *row;
 int rowEnd[16],maxRow;
 char *label;
 char texts;


 currentCalView=DAY_CAL;
 clearActiveCal();


 t0 = currentDate;
 t1 = currentDate;
 t0.beginningOfDay();
 t1.endOfDay();
 
 calFilter.from = mktime(&t0.tm);
 calFilter.to   = mktime(&t1.tm);
 sel = cal.select(&calFilter);
 
 if( currentCalTopTB  != DAY_CAL)
  {
   topTB->begin();
   
   dayCalMonPlus = new Fl_Button (149,0,11,14,"M");
   dayCalMonPlus->size(12,14);
   dayCalMonPlus->labelsize(9);
   dayCalMonPlus->callback(dayCalPlusMon);
   
   dayCalWeekPlus = new Fl_Button (138,0,11,14,"W");
   dayCalWeekPlus->labelsize(9);
   dayCalWeekPlus->callback(dayCalPlusWeek);
   dayCalDayPlus = new Fl_Button (127,0,11,14,"D");
   dayCalDayPlus->labelsize(9);
   dayCalDayPlus->callback(dayCalPlusDay);
   dayCalDayPlus->shortcut(FL_Right);
   
   strftime(tx,64,"%a, %d.%b.%Y",&t0.tm);
   dayCalHead = new Fl_Box(33,0,94,14,tx);
   dayCalHead->box(FL_UP_BOX);
   dayCalHead->labelsize(10);
   
   dayCalMonMinus = new Fl_Button (0,0,11,14,"M");
   dayCalMonMinus->labelsize(9);
   dayCalMonMinus->callback(dayCalMinusMon);
   dayCalWeekMinus = new Fl_Button (11,0,11,14,"W");
   dayCalWeekMinus->labelsize(9);
   dayCalWeekMinus->callback(dayCalMinusWeek);
   dayCalDayMinus = new Fl_Button (22,0,11,14,"D");
   dayCalDayMinus->labelsize(9);
   dayCalDayMinus->callback(dayCalMinusDay);
   dayCalDayMinus->shortcut(FL_Left);
   
   topTB->end();
   currentCalTopTB   = DAY_CAL;
  }
 else
  {
   strftime(tx,64,"%a, %d.%b.%Y",&t0.tm);
   dayCalHead->label(tx);
   dayCalHead->redraw();
  }
 activeCal->begin();

 // printf("select done1\n");

 tl.reset();
 timeDef today,evening;
 today=currentDate;
 today.sec=0;
 today.min=0;
 today.hour=kernStart;
 today.set();
 while(today.hour <= kernEnd)
  {
   tl.add(&today);
   today.hour++;
   today.tim+= 3600;
  }
 today.beginningOfDay();
 evening=today;
 evening.endOfDay();
 // printf("Looking at %8d to %8d\n",today.tim,evening.tim);
//  for(int h=kernStart; h<= kernEnd; h++)
//   tl._add(h,0);

 maxRow=0;

 if(sel != NULL)
  {
   for(int i=0;i<sel->count; i++)
    {
     struct tm *lt;
     int m0,h0,m1,h1,tim;
     char tx[2][64];

     if(sel->app[i]->app->journal)
      {
       tl.addJournal(sel->app[i]->app->title,i);
      }
     else
      {
       timeDef start,stop;
       start.set(sel->app[i]->start);
       stop.set(sel->app[i]->stop);
       tl.add(&start,&stop,&today,&evening,sel->app[i]->app->title,i);
      }
#ifdef DEBUG
     strftime(tx[0],63,"%y-%m-%d %H:%M",localtime((time_t *) &sel->app[i]->app->start));
     strftime(tx[1],63,"%y-%m-%d %H:%M",localtime((time_t *) &sel->app[i]->app->stop));
     fprintf(fpl,"%2d: %2d:%02d %2d:%02d  %36s :: start=%8d/%16s  stop=%8d/%16s rep=%1d\n",i,h0,m0,h1,m1,sel->app[i]->app->title,
	    sel->app[i]->app->start,tx[0],
	    sel->app[i]->app->stop,tx[1],
	    sel->app[i]->app->rep.type);
//      strftime(tx[0],63,"%y-%m-%d %H:%M",localtime((time_t *) &sel->app[i]->start));
//      strftime(tx[1],63,"%y-%m-%d %H:%M",localtime((time_t *) &sel->app[i]->stop));
//      printf("%2d: %2d:%02d %2d:%02d  %36s :: start=%8d/%16s  stop=%8d/%16s\n",i,h0,m0,h1,m1,sel->app[i]->app->title,
// 	    sel->app[i]->start,tx[0],
// 	    sel->app[i]->stop,tx[1]);

//      strftime(tx[0],63,"%y-%m-%d %H:%M",localtime((time_t *) &sel->app[i]->app->rep.until));
//       printf("\t\t\t\tREP: type=%d intervall=%d until=%8d/%s wim=%d flags=%02X exanz=%d\n",
//  	    sel->app[i]->app->rep.type,sel->app[i]->app->rep.intervall,
//  	    sel->app[i]->app->rep.until,tx[0],
//  	    sel->app[i]->app->rep.weekInMonth,sel->app[i]->app->rep.dayFlags,sel->app[i]->app->rep.exceptionCount);
#endif
    }
  }

//  for(int i=0;i<tl.anz; i++)
//   printf("line %d /%p : %p  /%s/ aid=%d\n",i,&tl.line[i],tl.line[i].txt,tl.line[i].label,tl.line[i].aid);
 tl.sort();
//  for(int i=0;i<tl.anz; i++)
//   printf("line %d : %s: /%s/\n",i,tl.line[i].label,tl.line[i].txt);

// dayCalLines =  new (Fl_Button *)  [tl.anz ];
 dayCalLines =  new (Fl_Button *)  [tl.anz ];
 dayCalApp = new (Fl_Button *) [tl.anz];
 if(sel != NULL )
  {
    if(sel->count >0)
    dayCalAppBox =  new (Fl_Box *)  [sel->count ];
  }

//  printf("select done3 %p\n",tl.line[1].txt);
 int xoff = tl.maxRow *2;
 int a=0,l2;
 for(int l=0;l<tl.anz; l++)
  {
   dayCalLines[l] =  new Fl_Button(4,11*l,28,11,tl.line[l].label);
   dayCalLines[l]->labelsize(10);
   dayCalLines[l]->align(FL_ALIGN_RIGHT|FL_ALIGN_INSIDE);
   dayCalLines[l]->box(FL_FLAT_BOX);
   dayCalLines[l]->color(FL_WHITE);
   dayCalApp[l] = new Fl_Button(34+xoff,l*11,128-xoff,11);
   dayCalApp[l]->labelsize(10);
   dayCalApp[l]->box(FL_FLAT_BOX);
   dayCalApp[l]->color(FL_WHITE);
   dayCalApp[l]->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
   if(tl.line[l].txt == NULL )
    if(tl.line[l].label != NULL)
     if(strchr(tl.line[l].label,':') != NULL)
      {
       dayCalApp[l]->callback(newApp,(void *)tl.line[l].label);
       dayCalLines[l]->callback(newApp,(void *)tl.line[l].label);
      }
  }

 for(int l=0;l<tl.anz; l++)
  if(tl.line[l].txt != NULL )
   {
    dayCalApp[l]->callback(editAppointment,(void *)sel->app[tl.line[l].aid]);
    dayCalApp[l]->label(tl.line[l].txt);
#ifdef DEBUG
    fprintf(fpl,"DRAW: %d %p '%s'/%p\n->> '%s'/%p",l,tl.line[l].txt,tl.line[l].txt,tl.line[l].txt, dayCalApp[l]->label(), dayCalApp[l]->label());
#endif
//     printf("DRAW: %d '%s'  id=%3d inst=%p tim=%8d/%8d app=%p \n",l,tl.line[l].txt,tl.line[l].aid,
// 	   sel->app[tl.line[l].aid],sel->app[tl.line[l].aid]->start,sel->app[tl.line[l].aid]->stop,
// 	   sel->app[tl.line[l].aid]->app);
//      printf("     tl: label='%s' tim=%8d row=%1d end=%8d aid=%3d  /%s/\n",
// 	    tl.line[l].label, tl.line[l].tim, tl.line[l].row, tl.line[l].end, tl.line[l].aid, tl.line[l].txt);
    if( tl.line[l].end >0)
     {
      l2 = tl.findFirst(tl.line[l].end,l);
      if(l2>0)
       {
	dayCalAppBox[a] = new Fl_Box(29, l*11+6,  4+tl.line[l].row*2,  (l2-l)*11-3);
	dayCalAppBox[a]->box(DAYCAL_BOX);
	a++;
       }
     }
   }
 //#endif

 activeCal->end();
 // s->show();
 // s->auto_adjust();
 //activeCal->add(s);
 //  calWindow->add(s);
  calWindow->contents()->resizable(activeCal);

//  activeCal->end();
//  activeCal->redraw();
  calWindow->redraw();
  activeCal->hide();     // Sonst passiert kein redraw :-(
  activeCal->show();

 // printf("select done6\n");

}


void drawDayCalBox(int x, int y, int w, int h, Fl_Color c)
{
 int x1 = x+w;
 int y1 = y+h  ;
 fl_color(FL_BLACK);
 fl_line(x ,y ,x1,y ,x1,y1);
 fl_line(x ,y1,x1,y1);
}

void dayCalPlusMon(Fl_Widget *w)
{
 currentDate.skip2NextMonth();
 drawDayCalWindow();
}
void dayCalPlusWeek(Fl_Widget *w)
{
 currentDate.skip2NextWeek();
 drawDayCalWindow();
}
void dayCalPlusDay(Fl_Widget *w)
{
 currentDate.skip2NextDay();
 drawDayCalWindow();
}
void dayCalMinusMon(Fl_Widget *w)
{
 currentDate.skip2PrevMonth();
 drawDayCalWindow();
}
void dayCalMinusWeek(Fl_Widget *w)
{
 currentDate.skip2PrevWeek();
 drawDayCalWindow();
}
void dayCalMinusDay(Fl_Widget *w)
{
 currentDate.skip2PrevDay();
 drawDayCalWindow();
}
