// File: editApp.cc
//
// Time-stamp: <01-Jun-2003 19:38:56 goetz>
// $Id: $
//
// Copyright (C) 2003 by Rdiger Goetz
//
// Author: Ruediger Goetz
//
// Description: 
// 
//

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <unistd.h>
#include <time.h>

#include "calendrian.h"
//#include "acal_gui.h"

int editAppFillRoundButton(Fl_Round_Button *b,int flag);
int editAppReadRoundButton(Fl_Round_Button *b);
int editAppSaveDate2Current();
int editAppSaveEventAlarm();
int editAppSaveEventAlarm(int a);
int editAppSaveJournalAlarm();
int editAppSaveJournalAlarm(int a);
void readTimeStr(const char *t, int *hour, int * min);
void readTimeStr(const char *t,timeDef *td);

void setLocation(Fl_Widget *w,void *loc);
void setStatus(Fl_Widget *w,void * loc);
void editAppCancel(Fl_Widget *w);
void editAppExit(Fl_Widget *w);
void editAppDelete(Fl_Widget *w);
void editAppDoDelete();
void editAppCopy(Fl_Widget *w);
void editAppCut(Fl_Widget *w);
void editAppPaste(Fl_Widget *w);
void editAppInternal(Fl_Widget *w);
void editAppHelp(Fl_Widget *w);
void editAppAdvanced(Fl_Widget *w);
void editAppToggleJournal(Fl_Widget *w);
void editAppUpdateJournalState();
void editAppDisplayStartTime();
void editAppDisplayStopTime();
void editAppBeginDateMinPlus(Fl_Widget *w);
void editAppBeginDateMinMinus(Fl_Widget *w);
void editAppBeginDateHourPlus(Fl_Widget *w);
void editAppBeginDateHourMinus(Fl_Widget *w);
void editAppEndDateMinPlus(Fl_Widget *w);
void editAppEndDateMinMinus(Fl_Widget *w);
void editAppEndDateHourPlus(Fl_Widget *w);
void editAppEndDateHourMinus(Fl_Widget *w);
void editAppSetBeginDate(Fl_Widget *w);
void editAppSetEndDate(Fl_Widget *w);
int drawEditDateTab( ) ;

int indexInArray(const char *t, char *array[], int size,int err);

int drawEditAlarmTab( ) ;
int  editAppFillEventAlarm();
int  editAppFillEventAlarm(int a);
int  editAppFillJournalAlarm();
int  editAppFillJournalAlarm(int a);
void editAppToggleAlarm(Fl_Widget *w,void *d);
void editAppCheckAlarmValue(Fl_Widget *w,void *d);
void editAppSetJournalAlarmDate(Fl_Widget *w,void *d);
void editAppDoSetJournalAlarmDate(timeDef sel);
void editAppDisplayJournalAlarmTime(int nr);


int drawEditDescrTab();


// repeat tab
int drawEditRepeatTab();
void editAppSetRepeatType(Fl_Widget *, void *dummy);
void editAppUpdateRepeatTab(int type);
void editAppFillRepeatTab(AppointmentRepeat *ar);
void editAppSetRepUntilDate(Fl_Widget *w);


void editAppShowInternalInfo();

// Alarm Tab
static Fl_Round_Button * editAppEnaAlarm[4];
static Fl_Menu_Button *editAppAlarmUnitMenu[4];
static Fl_Input *editAlarmIntervall[4];

// repeat Tab
static Fl_Box * editAppRepeatTypeLabel, *editAppRepEveryLabel, *editAppRepEveryLabel2;
static Fl_Box *editAppRepOnLabel,*editAppRepWeekNrLabel,*editAppRepUntilLabel;
static Fl_Menu_Button *editAppRepeatTypeMenu;
static Fl_Input *editAppRepEvery,*editAppRepWeekNr;
static Fl_Button *editAppRepDays[7],*editAppRepUntil;
static Fl_Group *editAppRepDayGroup;



extern Fl_App_Window *calWindow;
Fl_App_Window  *editAppWindow;
//extern Fl_Group *activeCal;


static Fl_Button *editAppDone,*editAppJournal;
static Fl_Menu_Button *editAppEditMenu,*editAppCategories;

static Fl_Tabs  *editAppTabs ;
static Fl_Group *editAppDateGroup , *editAppAlarmGroup, *editAppRepeatGroup, *editAppDescrGroup;
static Fl_Group *editAppEventAlarmGroup, *editAppJournalAlarmGroup;
static Fl_Box * editAppTitle, *editAppLabelBegin, *editAppLabelEnd,*editAppDateSep;
static Fl_Input * editAppTitleInput, *editAppBegin, *editAppEnd;
static Fl_Button *editAppDateBegin, *editAppDateEnd;
static Fl_Button *editAppBeginHourPlus, *editAppBeginHourMinus, *editAppBeginMinPlus, *editAppBeginMinMinus ;
static Fl_Button *editAppEndHourPlus, *editAppEndHourMinus, *editAppEndMinPlus, *editAppEndMinMinus ;
static Fl_Box    *editAppLabelLocation,*editAppLabelAlarm,*editAppLabelRepeat,*editAppLabelStatus;
static Fl_Box    *editAppLabelDescr;
static Fl_Box    *editAppRepeatRemark,*editAppRepeatRemark2;
static Fl_Menu_Button *editAppLocationMenu, *editAppStatusMenu ;
static Fl_Input *editAppLocationEntry;
static Fl_Multiline_Input *editAppDescr;
static Fl_Round_Button * editAppPrivate,*editAppHidden,*editAppCanceled;

// static Fl_Button *editAppJournalAlarmHourPlus[4], *editAppJournalAlarmHourMinus[4];
// static Fl_Button *editAppJournalAlarmMinPlus[4], *editAppJournalAlarmMinMinus[4] ;
static Fl_Input *editAppJournalAlarm[4]; 
static Fl_Button * editAppDateJournalAlarm[4];
static Fl_Button *editAppAlarm,*editAppRepeat;

//static Fl_Group *editAppWindow;
static Fl_Menu_Item editAppMenuItems [] = {
{ "Cancel",  0,(Fl_Callback *) editAppCancel  },
{ "Delete",  0,(Fl_Callback *) editAppDelete  ,(void *) 0,FL_MENU_DIVIDER|FL_MENU_INACTIVE},
{ "Copy",    0,(Fl_Callback *) editAppCopy    ,(void *) 0,FL_MENU_INACTIVE},
{ "Cut",     0,(Fl_Callback *) editAppCut     ,(void *) 0,FL_MENU_INACTIVE},
{ "Paste",   0,(Fl_Callback *) editAppPaste   ,(void *) 0,FL_MENU_DIVIDER|FL_MENU_INACTIVE},
{ "Internal",0,(Fl_Callback *) editAppShowInternalInfo},
{ "Help",    0,(Fl_Callback *) editAppHelp    ,(void *) 0,FL_MENU_INACTIVE},
{0}
};
static Fl_Dockable_Window *editTB;
Fl_Menu_Button *editTBeditMenu, *editTBcatMenu;
Fl_Button *editTBDone,*editTBjournal;

static timeDef curStart,curStop,curRepUntil ,curAlarmDate[4];
static int curAlarmNr;
static char startDate[32],stopDate[32],startTime[32],stopTime[32],repUntilDate[32],repeatRemarkDateText[128];
static char alarmDateStr[4][32],alarmTimeStr[4][32];
static Appointment curApp;
static AppointmentInstance *origApp;
Fl_Callback *falle;

Fl_Dockable_Window *editAppMenu;
//Fl_Group *editAppMenu;

extern Calendar cal;


int drawEditMenu()
{
 editTB =  WidgetFactory::new_toolbar();
 editTB->begin();


 editTBDone = WidgetFactory::new_button("");
 editTBDone->label("Done");
 editTBDone->resize(0,0,32,16);
 editTBDone->callback(editAppExit);
 editTBDone->show();

 editTBeditMenu= WidgetFactory::new_menu_button("");
 editTBeditMenu->label("Edit");
 editTBeditMenu->resize(32,0,36,16);
 editTBeditMenu->menu(editAppMenuItems);
 editTBeditMenu->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
 editTBeditMenu->show();

 editTBjournal = WidgetFactory::new_button("");
 editTBjournal->label("Journal");
 editTBjournal->resize(68,0,40,16);
 editTBjournal->callback(editAppToggleJournal);
 editTBjournal->show();

 editTBcatMenu= WidgetFactory::new_menu_button("");
 editTBcatMenu->label("All");
 editTBcatMenu->resize(108,0,52,16);
 editTBcatMenu->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 editAppFillCategoriesMenu();
 editTB->end();
 editAppWindow->add_dockable(editTB,1);
}

void editAppFillCategoriesMenu()
{
 int last=-1;
 int c=0;

 editTBcatMenu->clear();

 for(int i=0;i<MAX_CATEGORIES; i++) 
  if(categories[i]!=NULL)
   {
    editTBcatMenu->add(categories[i],0,(Fl_Callback *) setCategory,(void *) i);
    editTBcatMenu->textsize(10);
    last=c;
    c++;
   }
 editTBcatMenu->mode(last,FL_MENU_DIVIDER  );
 editTBcatMenu->mode(last,FL_MENU_DIVIDER  );
 editTBcatMenu->add("Edit Categories",0,(Fl_Callback *) editCategories,(void *)editAppFillCategoriesMenu);
 editTBcatMenu->textsize(10);
 editTBcatMenu->redraw();
}

void editAppointment(Fl_Widget *w, void *a) 
{
 AppointmentInstance *ai = (AppointmentInstance * ) a;
//  printf("editAPP: w=%p a=%p\n",w,a);

 drawEditAppointment(   );
 editAppFill(ai);
}
void editAppointment(Appointment *app)
{
 AppointmentInstance ai;
 ai.app = app;
 ai.stop = app->stop;
 drawEditAppointment(   );
 editAppFill(&ai);

}
void editAppointment(timeDef *start)
{
 drawEditAppointment(   );
 editAppFill(NULL,start);
}

void editAppFill(AppointmentInstance *ai,timeDef *start )
{
 Appointment *app = NULL;
 AppointmentInstance inst;
 origApp = ai;


 if(ai != NULL)
  {
   app = ai->app;
   curApp.copy(app);
   curApp.id = app->id;
   //   printf("edit ID %d  (%p), %d\n",curApp.id,curApp,app->id);
   editTBeditMenu->mode(1,FL_MENU_DIVIDER);
   inst.app = app;
   inst.start = ai->start;
   inst.stop  = ai->stop;
   curStart.set(inst.start);
   curStart.sec=0;
   curStart.set();
   curStop.set(inst.stop);
   curStop.sec=0;
   curStop.set();
  }
 else
  {
   editTBeditMenu->mode(1,FL_MENU_DIVIDER|FL_MENU_INACTIVE);
   curApp.reset0();

   //   printf("START=%p %8d %d %d\n",start,start->tim,start->hour,start->min);
   if(start != NULL)
    {
     curStart = start;
     curStart.sec=0;
     curStart.set();
     curApp.start = curStart.tim;
    }
   //    curApp.start =start->tim;
   else
    {
     curStart.set(time(NULL));
     curStart.sec=0;
     curStart.set();
     curApp.start = curStart.tim;
    }
   curApp.stop  = curApp.start +3600;
   curStop.set(curApp.stop);
   inst.app=app;
   inst.start = curApp.start;
   inst.stop  = curApp.stop;
  }
 editTBeditMenu->redraw();
 editAppTitleInput->value(curApp.title);


 strftime(startDate,31,"%d.%b.%Y",&curStart.tm);
 editAppDateBegin->label(startDate);
 editAppDisplayStartTime();

 strftime(stopDate,31,"%d.%b.%Y",&curStop.tm);
 editAppDateEnd->label(stopDate);
 editAppDisplayStopTime();

 if(curApp.rep.type != REPEAT_TYPE_NONE)
  {
   char txt[32];
   timeDef rt;
   rt.set(curApp.start);
   strftime(txt,31,"%d.%b.%Y, %H:%M",&rt.tm);
   sprintf(repeatRemarkDateText,"first at %s\n",txt);
   editAppRepeatRemark->label("Repeated Appointment started");
   editAppRepeatRemark2->label(repeatRemarkDateText);
  }

 editAppFillRoundButton(editAppPrivate,curApp.priv);
 editAppFillRoundButton(editAppHidden,curApp.hidden);
 editAppFillRoundButton(editAppCanceled,curApp.canceled);
 editAppLocationEntry->value(curApp.location);
 editTBcatMenu->label(categories[curApp.category]);
 editTBcatMenu->redraw();


 if(curApp.journal)
  editAppFillJournalAlarm();
 else
  editAppFillEventAlarm();
 editAppUpdateJournalState();

 editAppDescr->value(curApp.descr);
 editAppFillRepeatTab(&curApp.rep);
 

 editAppWindow->redraw();
}

int editAppSaveDate2Current()
{
 char *t;

 t = (char *) editAppTitleInput->value();
 while (*t==' ' || *t =='\t' || *t == '\n')
  t++;

 if( *t=='\0')
  if(fl_ask("You are about to save an Appointment with empty title. Continue?") ==0)
   return false;

 curApp.fillTitle(t);
 curApp.fillDescr(editAppDescr->value());
 curApp.priv     = editAppReadRoundButton(editAppPrivate);
 curApp.hidden   = editAppReadRoundButton(editAppHidden);
 curApp.canceled = editAppReadRoundButton(editAppCanceled);
 curApp.category = indexInArray(editTBcatMenu->label(),categories,MAX_CATEGORIES,0);
 if(curApp.journal)
  {
   curStart.beginningOfDay();
   curStop.endOfDay();
   curApp.start = curStart.tim;
   curApp.stop  = curStop.tim;
   curApp.rep.type = REPEAT_TYPE_NONE;
   editAppSaveJournalAlarm();
  }
 else
  {
   readTimeStr(editAppBegin->value(),&curStart);
   readTimeStr(editAppEnd->value(),&curStop);
   curApp.start = curStart.tim;
   curApp.stop  = curStop.tim;
   // curApp.location = indexInArray(editAppLocationMenu->label(),locations,MAX_LOCATION,0); // FIXME
   curApp.fillLocation(editAppLocationEntry->value());

   editAppSaveEventAlarm();
   
   int repType,repIntervall,repDays,repWeek;
   repType = indexInArray(editAppRepeatTypeMenu->label(),repeatTypes,6,0);
   if(repType != GUI_REPEAT_TYPE_NONE)
    {
     repIntervall = atoi(editAppRepEvery->value());
     repDays =0;
     repWeek =-1;
     if(repType == GUI_REPEAT_TYPE_WEEK)
      {
       int b=1;
       repDays =0;
       for(int j=0;j<7;j++)
	{
	 if(editAppRepDays[j]->value() == 1)
	  repDays += b;
	 b = b<<1;
	}
      }
     if(repType == GUI_REPEAT_TYPE_MONTH_BY_DAY )
      {
       int b=1;
       repDays =0;
       for(int j=0;j<7;j++)
	{
	 if(editAppRepDays[j]->value() == 1)
	  repDays = b;
	 b = b<<1;
	}
       repWeek = atoi(editAppRepWeekNr->value()) -1;
      }
     curApp.rep.fill(curApp.start,repeatType2[repType],repIntervall,repWeek,repDays,curRepUntil.tim);
    }
   else
    curApp.rep.fill(curApp.start,repType,0,0,0,0);
  }
 
 
 if(origApp != NULL)
  if(origApp->app->rep.type != REPEAT_TYPE_NONE)
   {
    char txt[64];
    struct tm *lt;
    lt=localtime((const time_t *) &origApp->start);
    strftime(txt,63,"%a, %d.%b.%Y, %H:%M",lt);
    int ans =fl_choice("Do you want to modify all of this appointment, or only the current event at %s?","Current","All","Cancel",txt) ;
    if(ans == 0) 
     {
      origApp->app->addException(origApp->start);
      curApp.id =-1;
      curApp.rep.type = REPEAT_TYPE_NONE;
     }
    if(ans==2)
     return false;
   }


 // printf("4MODIFY %p : alarm 0 = %d %d\n",&curApp,curApp.alarm[0],curApp.alarmTime[0]);
 cal.modify(&curApp);
 return true;
}

int editAppSaveEventAlarm()
{
 for(int a=0;a<4 ;a++)
  editAppSaveEventAlarm(a);
}
int editAppSaveEventAlarm(int a)
{
 if(editAppEnaAlarm[a]->value() ==0)
  curApp.alarm[a] =-1;
 else
  {
   int unit,val;
   unit = indexInArray(editAppAlarmUnitMenu[a]->label(),timeUnits,6,0);
   val  = atoi(editAlarmIntervall[a]->value());
   curApp.alarm[a] = val * timeUnitMin[unit];
  }
 curApp.alarm2alarmTime();
}
int editAppSaveJournalAlarm()
{
 for(int a=0;a<4 ;a++)
  editAppSaveJournalAlarm(a);
}
int editAppSaveJournalAlarm(int a)
{
 if(editAppEnaAlarm[a]->value() ==0)
  curApp.alarm[a] =-1;
 else
  {
   curApp.alarm[a] = 0;
//    printf("save AlarmTime: %s\n",editAppJournalAlarm[a]->value());
//    curAlarmDate[a].print();
   readTimeStr(editAppJournalAlarm[a]->value(),&curAlarmDate[a].hour,& curAlarmDate[a].min);
//    curAlarmDate[a].print();
   curAlarmDate[a].set();
//    curAlarmDate[a].print();
   curApp.alarmTime[a] = curAlarmDate[a].tim;
//    printf("save JOunral Alarm: %d %d\n",curApp.alarm[a],curApp.alarmTime[a]);
//    curAlarmDate[a].print();
   
   // printf("alarmTime=%8d\n",curApp.alarmTime[a]);
  }
 curApp.alarmTime2alarm();
}

void readTimeStr(const char *t, timeDef *td)
{
 readTimeStr(t,&td->hour,&td->min);
 td->set();
}
void readTimeStr(const char *t, int *hour, int * min)
{
 int h=0,m=0;

 // printf("read Time: //%c,%c,%c,%c,%c//\n",t[0],t[1],t[2],t[3],t[4]);
 if( t[2] == ':' )
  {
   if ( t[0] == '1')
    h= 10;
   if ( t[0] == '2')
    h= 20;
   h+= t[1] -'0';
 
   m = 10 *(t[3] - '0') + (t[4] - '0');
   //    printf("readTime2: %d : %d <-%s\n",h,m,t);
   if(0<=h && h < 24 && 0 <= m && m<60)
    {
     *hour =h;
     *min =m;
    }
  }
 else if( t[1] == ':' )
  {
   h+= t[0] -'0';
 
   m = 10 *(t[2] - '0') + (t[3] - '0');
   //    printf("readTime1: %d : %d <-%s\n",h,m,t);
   if(0<=h && h < 24 && 0 <= m && m<60)
    {
     *hour =h;
     *min =m;
    }
  }
}

int indexInArray(const char *t, char *array[], int size,int err)
{
 int tl=strlen(t);
 for(int i=0;i<size; i++)
  if(array[i] != NULL)
   if(strlen(array[i]) == tl )
    if(strcmp(array[i],t) == 0)
     return i;
 return err;
}

int editAppFillRoundButton(Fl_Round_Button *b,int flag)
{
 if(flag)
  b->value(1);
 else
  b->value(0);
 b->redraw();
}
int editAppReadRoundButton(Fl_Round_Button *b)
{
 if(b->value()==1)
  return true;
 else
  return false;
}

int  drawEditAppointment(   )
{
 editAppWindow = WidgetFactory::new_window("Calendrian Edit");



 editAppTitle = new Fl_Box(2,4,158,12,"Appointment title:");
 editAppTitle->box(FL_NO_BOX);
 editAppTitle->labelsize(10);
 editAppTitle->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 editAppTitleInput = new  Fl_Input(2,15,158,14);
 editAppTitleInput->textsize(10);

 editAppTabs =  new Fl_Tabs(0,31,160,174);
 editAppTabs->labelsize(10);
 editAppTabs->color(FL_WHITE);

 editAppDateGroup = new Fl_Group(0,44,160,160,"Date");
 editAppAlarmGroup = new Fl_Group(0,44,160,160,"Alarm");
 editAppEventAlarmGroup = new Fl_Group(64,44,96,160);
 editAppJournalAlarmGroup = new Fl_Group(64,44,96,160);
 editAppRepeatGroup = new Fl_Group(0,44,160,160,"Repeat");
 editAppDescrGroup = new Fl_Group(0,44,160,160,"Descr.");
 editAppDateGroup->labelsize(10);
 editAppAlarmGroup->labelsize(10);
 editAppRepeatGroup->labelsize(10);
 editAppDescrGroup->labelsize(10);
 editAppDateGroup->color(FL_WHITE);
 editAppAlarmGroup->color(FL_WHITE);
 editAppRepeatGroup->color(FL_WHITE);
 editAppDescrGroup->color(FL_WHITE);

 editAppTabs->add(editAppDateGroup);
 editAppTabs->add(editAppAlarmGroup);
 editAppTabs->add(editAppRepeatGroup);
 editAppTabs->add(editAppDescrGroup);
 drawEditMenu();
 editAppWindow->end();
 
 drawEditDateTab();
 drawEditAlarmTab();
 drawEditRepeatTab();
 drawEditDescrTab();

 editAppWindow->show();
 calWindow->hide();


}


int drawEditDateTab( ) 
{
 // static int lp[16]={0, 2,16,33,47,62,84, 98,112,126,146,153,168,183,198,213};
 int lp[10]={48,64,80,104,128,142,156,178,190};

 editAppDateGroup ->begin();

 editAppLabelBegin = new Fl_Box(2,lp[0],70,12,"Begin");
 editAppLabelBegin->box(FL_NO_BOX);
 editAppLabelBegin->labelsize(10);
 editAppLabelBegin->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);

 editAppDateSep = new Fl_Box(74,lp[0],14,12,"-");
 editAppDateSep->box(FL_NO_BOX);
 editAppDateSep->labelsize(10);
 editAppDateSep->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);

 editAppLabelEnd = new Fl_Box(90,lp[0],70,12,"End");
 editAppLabelEnd->box(FL_NO_BOX);
 editAppLabelEnd->labelsize(10);
 editAppLabelEnd->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);

 editAppDateBegin = new Fl_Button(2,lp[1],72,14,"01-01-1970");
 editAppDateBegin->labelsize(10);
 editAppDateBegin->callback(editAppSetBeginDate);
 // editAppDateBegin->when(FL_WHEN_RELEASE);

 editAppDateEnd   = new Fl_Button(86,lp[1],72,14,"01-02-1970");
 editAppDateEnd->labelsize(10);
 editAppDateEnd->callback(editAppSetEndDate);


 editAppBeginHourPlus = new Fl_Button(2,lp[2],9,8,"+ ");
 editAppBeginHourPlus->labeltype(CAL_UP_LABEL);
 editAppBeginHourPlus->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
 editAppBeginHourPlus->callback(editAppBeginDateHourPlus);
 editAppBeginHourMinus = new Fl_Button(2,lp[2]+8,9,8,"-");
 editAppBeginHourMinus->labeltype(CAL_UP_LABEL);
 editAppBeginHourMinus->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
 editAppBeginHourMinus->callback(editAppBeginDateHourMinus);
 editAppBegin = new  Fl_Input(10,lp[2]-1,56,19);
 editAppBegin->textsize(10);
 editAppBegin->value("22:58 am");
 editAppBeginMinPlus = new Fl_Button(65,lp[2],9,8,"+ ");
 editAppBeginMinPlus->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
 editAppBeginMinPlus->callback(editAppBeginDateMinPlus);
 editAppBeginMinPlus->labeltype(CAL_UP_LABEL);
 editAppBeginMinMinus = new Fl_Button(65,lp[2]+8,9,8,"-");
 editAppBeginMinMinus->labeltype(CAL_UP_LABEL);
 // editAppBeginMinMinus->labelsize(5);
 editAppBeginMinMinus->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
 editAppBeginMinMinus->callback(editAppBeginDateMinMinus);

 editAppEndHourPlus = new Fl_Button(86,lp[2],9,8,"+ ");
 editAppEndHourPlus->labeltype(CAL_UP_LABEL);
 editAppEndHourPlus->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
 editAppEndHourPlus->callback(editAppEndDateHourPlus);
 editAppEndHourMinus = new Fl_Button(86,lp[2]+8,9,8,"-");
 // editAppEndHourMinus->labelsize(5);
 editAppEndHourMinus->labeltype(CAL_UP_LABEL);
 editAppEndHourMinus->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
 editAppEndHourMinus->callback(editAppEndDateHourMinus);
 editAppEnd = new  Fl_Input(94,lp[2]-1,56,19);
 editAppEnd->textsize(10);
 editAppEnd->value("23:58 pm");
 editAppEndMinPlus = new Fl_Button(149,lp[2],9,8,"+ ");
 editAppEndMinPlus->labeltype(CAL_UP_LABEL);
 editAppEndMinPlus->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
 editAppEndMinPlus->callback(editAppEndDateMinPlus);
 editAppEndMinMinus = new Fl_Button(149,lp[2]+8,9,8,"-");
 // editAppEndMinMinus->labelsize(5);
 editAppEndMinMinus->labeltype(CAL_UP_LABEL);
 editAppEndMinMinus->callback(editAppEndDateMinMinus);
 editAppEndMinMinus->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
  
 editAppLabelLocation = new Fl_Box(2,lp[3],46,14,"Location");
 editAppLabelLocation->box(FL_NO_BOX);
 editAppLabelLocation->labelsize(10);
 editAppLabelLocation->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 editAppLocationEntry = new Fl_Input(48,lp[3],96,14);
 editAppLocationEntry->labelsize(10);
 editAppLocationEntry->textsize(10);
 
 editAppLocationMenu = new Fl_Menu_Button(144,lp[3],13,13);
 editAppLocationMenu->labelsize(10);
 editAppLocationMenu->labeltype(CAL_UP_LABEL);
 editAppLocationMenu->label("-");
 editAppFillLocationsMenu();

 
 editAppPrivate = new Fl_Round_Button(8,lp[4],156,14," private");
 editAppPrivate->labelsize(10);
 editAppHidden  = new Fl_Round_Button(8,lp[5],156,14," hidden");
 editAppHidden ->labelsize(10);
 editAppCanceled= new Fl_Round_Button(8,lp[6],156,14," canceled");
 editAppCanceled->labelsize(10);

 editAppRepeatRemark = new Fl_Box(2,lp[7],156,14,"");
 editAppRepeatRemark->box(FL_NO_BOX);
 editAppRepeatRemark->labelsize(10);
 editAppRepeatRemark->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
 editAppRepeatRemark2 = new Fl_Box(2,lp[8],156,14,"");
 editAppRepeatRemark2->box(FL_NO_BOX);
 editAppRepeatRemark2->labelsize(10);
 editAppRepeatRemark2->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);


 editAppDateGroup ->end();
}

// Date Call backs

void editAppDoSetBeginDate(timeDef sel)
{
 char tx[32];
 
 curStart = sel;
 strftime(startDate,31,"%d.%b.%Y",&curStart.tm);
 editAppDateBegin->redraw();
 
 if(curStart.tim> curStop.tim)
  {
   curStop.day = curStart.day;
   curStop.mon = curStart.mon;
   curStop.year= curStart.year;
   curStop.set();
   strftime(stopDate,31,"%d.%b.%Y",&curStop.tm);
   editAppDateEnd->redraw();
  }
}
void editAppSetBeginDate(Fl_Widget *w)
{
 selectDay(&curStart,editAppDoSetBeginDate);
 // selectDay(editAppDateBegin,startDate,&curStart);
}
void editAppDoSetEndDate(timeDef sel)
{
 char tx[32];
 
 curStop = sel;
 strftime(stopDate,31,"%d.%b.%Y",&curStop.tm);
 editAppDateEnd->redraw();

 if(curStart .tim> curStop.tim)
  {
   curStart.day = curStop.day;
   curStart.mon = curStop.mon;
   curStart.year= curStop.year;
   curStart.set();
   strftime(startDate,31,"%d.%b.%Y",&curStart.tm);
   editAppDateBegin->redraw();
  }
}
void editAppSetEndDate(Fl_Widget *w)
{
 selectDay(&curStop,editAppDoSetEndDate);
 //editAppDateEnd,stopDate,&curStop);
}

void editAppBeginDateMinPlus(Fl_Widget *w)
{
 readTimeStr(editAppBegin->value(),&curStart);
 curStart.min = (curStart.min+1) %60;
 curStart.set();
 editAppDisplayStartTime();
 if(curStart.tim > curStop.tim)
  {
   curStop.set(curStart.tim);
   editAppDisplayStopTime();
  }
 editAppWindow->redraw();
}
void editAppBeginDateMinMinus(Fl_Widget *w)
{
 readTimeStr(editAppBegin->value(),&curStart);
 curStart.min = (curStart.min+59) %60;
 curStart.set();
 editAppDisplayStartTime();
 if(curStart.tim > curStop.tim)
  {
   curStop.set(curStart.tim);
   editAppDisplayStopTime();
  }
 editAppWindow->redraw();
}
void editAppBeginDateHourPlus(Fl_Widget *w)
{
 readTimeStr(editAppBegin->value(),&curStart);
 curStart.hour = (curStart.hour+1) %24;
 curStart.set();
 editAppDisplayStartTime();
 if(curStart.tim > curStop.tim)
  {
   curStop.set(curStart.tim);
   editAppDisplayStopTime();
  }
 editAppWindow->redraw();
}
void editAppBeginDateHourMinus(Fl_Widget *w)
{
 readTimeStr(editAppBegin->value(),&curStart);
 curStart.hour = (curStart.hour+23) %24;
 curStart.set();
 editAppDisplayStartTime();
 if(curStart.tim > curStop.tim)
  {
   curStop.set(curStart.tim);
   editAppDisplayStopTime();
  }
 editAppWindow->redraw();
}
void editAppEndDateMinPlus(Fl_Widget *w)
{
 readTimeStr(editAppBegin->value(),&curStart);
 curStop.min = (curStop.min+1) %60;
 curStop.set();
 editAppDisplayStopTime();
 if(curStart.tim > curStop.tim)
  {
   curStart.set(curStop.tim);
   editAppDisplayStartTime();
  }
 editAppWindow->redraw();
}
void editAppEndDateMinMinus(Fl_Widget *w)
{
 readTimeStr(editAppBegin->value(),&curStart);
 curStop.min = (curStop.min+59) %60;
 curStop.set();
 editAppDisplayStopTime();
 if(curStart.tim > curStop.tim)
  {
   curStart.set(curStop.tim);
   editAppDisplayStartTime();
  }
 editAppWindow->redraw();
}
void editAppEndDateHourPlus(Fl_Widget *w)
{
 readTimeStr(editAppBegin->value(),&curStart);
 curStop.hour = (curStop.hour+1) %24;
 curStop.set();
 editAppDisplayStopTime();
 if(curStart.tim > curStop.tim)
  {
   curStart.set(curStop.tim);
   editAppDisplayStartTime();
  }
 editAppWindow->redraw();
}
void editAppEndDateHourMinus(Fl_Widget *w)
{
 readTimeStr(editAppBegin->value(),&curStart);
 curStop.hour = (curStop.hour+23) %24;
 curStop.set();
 editAppDisplayStopTime();
 if(curStart.tim > curStop.tim)
  {
   curStart.set(curStop.tim);
   editAppDisplayStartTime();
  }
 editAppWindow->redraw();
}

void setLocation(Fl_Widget *w,void * loc)
{
 int l=(int ) loc;
 // printf("set location to %d -> %s\n",l,locations[l]);
 // w->label(locations[l]);
 if(locations[l] != NULL)
  editAppLocationEntry->value(locations[l]);
 editAppLocationEntry->redraw();
}

void setStatus(Fl_Widget *w,void * loc)
{
 int l=(int ) loc;
 printf("set location to %d -> %s\n",l,stati[l]);
 w->label(stati[l]);
 w->redraw();
}



void editAppDisplayStartTime()
{
 sprintf(startTime,"%2d:%02d",curStart.hour,curStart.min);
 editAppBegin->value(startTime);
}
void editAppDisplayStopTime()
{
 sprintf(stopTime,"%2d:%02d",curStop.hour,curStop.min);
 editAppEnd->value(stopTime);
}

void editAppFillLocationsMenu()
{
 int ll=0;

 editAppLocationMenu->clear();

 editAppLocationMenu->add("Predefined Locations",0,NULL,0,FL_MENU_DIVIDER);
 editAppLocationMenu->textsize(10);

 ll=1;
 for(int i=0;i<MAX_LOCATION; i++)  
  if(locations[i]!=NULL)
   {
    editAppLocationMenu->add(locations[i],0,(Fl_Callback *) setLocation,(void *) i);
    editAppLocationMenu->textsize(10);
    ll++;
   }
 editAppLocationMenu->mode(ll-1,FL_MENU_DIVIDER);

 // editAppLocationMenu->add("Edit Locations",0,editLocation);
 editAppLocationMenu->add("Edit Locations",0,(Fl_Callback *) editLocation);
 editAppLocationMenu->textsize(10);
 editAppLocationMenu->redraw();

}



// Alarm Tab
int drawEditAlarmTab( ) 
{
 static int nr[4]={0,1,2,3};

 int y= 48;


 editAppAlarmGroup ->begin();
 for(int i=0;i<4; i++)
  {
   editAppEnaAlarm[i] = new Fl_Round_Button (4,y,64,14," Alarm at");
   editAppEnaAlarm[i]->labelsize(10);
   editAppEnaAlarm[i]->value(0);
   editAppEnaAlarm[i]->callback(editAppToggleAlarm,(void *) &nr[i]);
   y+= 24;
  }


 y=48;
 for(int i=0;i<4; i++) 
  {
   editAppJournalAlarm[i] = new  Fl_Input(60,y-1,36,19);
   editAppJournalAlarm[i]->textsize(10);
   editAppJournalAlarm[i]->value("0:00");

   strcpy(alarmDateStr[i],"-");
   editAppDateJournalAlarm[i] = new Fl_Button(96 ,y,64,14,alarmDateStr[i]);
   editAppDateJournalAlarm[i]->labelsize(10);
   editAppDateJournalAlarm[i]->callback(editAppSetJournalAlarmDate,(void *) i);

   editAppJournalAlarm[i]->deactivate();
   editAppDateJournalAlarm[i]->deactivate();
   y+=24;
  }

 y=48;
 for(int i=0;i<4; i++)
  {
   editAlarmIntervall[i] = new Fl_Input(66,y,24,14);
   editAlarmIntervall[i]->labelsize(10);
   editAlarmIntervall[i]->textsize(10);
   
   editAppAlarmUnitMenu[i] = new Fl_Menu_Button(94,y,64,14);
   editAppAlarmUnitMenu[i]->labelsize(10);
   for(int j=0; j<7; j++)
    {
     editAppAlarmUnitMenu[i]->add(timeUnits[j],0, (Fl_Callback*)editAppCheckAlarmValue,(void *) &nr[i]);
     editAppAlarmUnitMenu[i]->textsize(10);
    }
   editAppAlarmUnitMenu[i]->label(timeUnits[0]);

   editAppAlarmUnitMenu[i]->deactivate();
   editAlarmIntervall[i]->deactivate();
   y+=24;
  }


 editAppAlarmGroup ->end();
}

void editAppSetJournalAlarmDate(Fl_Widget *w,void *d)
{
 curAlarmNr = (int) d;
 selectDay(&curAlarmDate[curAlarmNr],editAppDoSetJournalAlarmDate);
}
void editAppDoSetJournalAlarmDate(timeDef sel)
{
 if(sel.tim < curStart.tim)
  {
   curAlarmDate[curAlarmNr] = sel;
   strftime(alarmDateStr[curAlarmNr],31,"%d.%b.%Y",&curAlarmDate[curAlarmNr].tm);
   editAppDateJournalAlarm[curAlarmNr]->redraw();
  }
}
void editAppDisplayJournalAlarmTime(int nr)
{
 sprintf(alarmTimeStr[nr],"%2d:%02d",curAlarmDate[nr].hour,curAlarmDate[nr].min);
 editAppJournalAlarm[nr]->value(alarmTimeStr[nr]);
}


void editAppToggleAlarm(Fl_Widget *w,void *d)
{
 int nr = *((int *) d);

 if( editAppEnaAlarm[nr]->value() == 1)
  {
   editAppAlarmUnitMenu[nr]->activate();
   editAlarmIntervall[nr]->activate();
   editAppJournalAlarm[nr]->activate();
   editAppDateJournalAlarm[nr]->activate();
   

   if(curApp.alarm[nr] <0)
    if(curApp.journal)
     {
      curAlarmDate[nr].set(curStart.tim - SECONDS_PER_DAY);
      strftime(alarmDateStr[nr],31,"%d.%b.%Y",&curAlarmDate[nr].tm);
      editAppDateJournalAlarm[nr]->redraw();
      editAppDisplayJournalAlarmTime(nr);
     }
    
  }
 else
  {
   editAppAlarmUnitMenu[nr]->deactivate();
   editAlarmIntervall[nr]->deactivate();
   editAppJournalAlarm[nr]->deactivate();
   editAppDateJournalAlarm[nr]->deactivate();
  }

 editAppEnaAlarm[nr]->redraw();
}

void editAppCheckAlarmValue(Fl_Widget *w,void *d)
{
 int nr = *((int *) d);
 Fl_Menu_Button *m = (Fl_Menu_Button *) w;

 m->label(timeUnits[m->value()]);
 m->redraw();
}


int  editAppFillEventAlarm()
{
 for(int a=0;a<4; a++)
  editAppFillEventAlarm(a);
}
int  editAppFillEventAlarm(int a)
{
//  printf("EventAlarm %d @ %d  / %d \n",a,curApp.alarm[a],curApp.alarmTime[a]);
 if(curApp.alarm[a]>=0)
  {
   int unit ;
   int val;
   char txt[16];
    
   

   if(curApp.alarm[a] > timeUnitMax[5])
    {
     curApp.alarm[a]=-1;
     return false;
    }

   if(curApp.alarm[a] == 0)
    {
     unit =0;
     val =0;
    }
   else
    {
     for(unit=5; unit >=0 ; unit--)
      {
       if(curApp.alarm[a]>=timeUnitMin[unit] && curApp.alarm[a] <= timeUnitMax[unit] )
	{
	 int m = curApp.alarm[a] % timeUnitMin[unit];
	 if ( m== 0)
	  {
	   break;
	  }
	}
       if(curApp.alarm[a]>timeUnitMax[unit])
	{
	 unit --;
	 break;
	}
      }
     val = (int)floor((double)curApp.alarm[a] / (double)timeUnitMin[unit] +0.5);
    }
   editAppEnaAlarm[a]->value(1);
   editAppToggleAlarm(editAppEnaAlarm[a],(void *) &a);
   sprintf(txt,"%d",val);
   editAlarmIntervall[a]->value(txt);
   editAppAlarmUnitMenu[a]->label(timeUnits[unit]);
   editAppEnaAlarm[a]->redraw();
   editAlarmIntervall[a]->redraw();
   editAppAlarmUnitMenu[a]->redraw();
  }
 else
  editAppEnaAlarm[a]->value(0);
 return true;
}
int  editAppFillJournalAlarm()
{
 for(int a =0;a<4; a++)
  editAppFillJournalAlarm(a);
}
int  editAppFillJournalAlarm(int a)
{
//  printf("fill JournalAlarm %d @ %d  / %d \n",a,curApp.alarm[a],curApp.alarmTime[a]);
 if(curApp.alarm[a]>=0)
  {
   curAlarmDate[a].set(curApp.alarmTime[a]);
   strftime(alarmDateStr[a],31,"%d.%b.%Y",&curAlarmDate[a].tm);
   editAppDateJournalAlarm[a]->redraw();
   editAppDisplayJournalAlarmTime(a);
   editAppEnaAlarm[a]->value(1);
   editAppToggleAlarm(editAppEnaAlarm[a],(void *) &a);
  }
 else
  editAppEnaAlarm[a]->value(0);
 return true;
}




int drawEditRepeatTab( ) 
{
 int lp[8]={55,80,100,120,140,0,0,0};

 editAppRepeatGroup ->begin();

 editAppRepeatTypeLabel = new Fl_Box(2,lp[0],34,14,"Type");
 editAppRepeatTypeLabel->box(FL_NO_BOX);
 editAppRepeatTypeLabel->labelsize(10);
 editAppRepeatTypeLabel->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 editAppRepeatTypeMenu = new Fl_Menu_Button(36,lp[0],122,14,"none");
 editAppRepeatTypeMenu->labelsize(10);
 for(int j=0;j<6;j++)
  {
   editAppRepeatTypeMenu->add(repeatTypes[j],0,(Fl_Callback *) editAppSetRepeatType);
   editAppRepeatTypeMenu->textsize(10);
  }

 editAppRepEveryLabel = new Fl_Box(2,lp[1],34,14,"Every");
 editAppRepEveryLabel->box(FL_NO_BOX);
 editAppRepEveryLabel->labelsize(10);
 editAppRepEveryLabel->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 editAppRepEvery = new Fl_Input(36,lp[1],24,14);
 editAppRepEvery->labelsize(10);
 editAppRepEvery->textsize(10);

 editAppRepEveryLabel2 = new Fl_Box(64,lp[1],72,14,"");
 editAppRepEveryLabel2->box(FL_NO_BOX);
 editAppRepEveryLabel2->labelsize(10);
 editAppRepEveryLabel2->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
 
 editAppRepOnLabel = new Fl_Box(2,lp[2],34,14,"On");
 editAppRepOnLabel->box(FL_NO_BOX);
 editAppRepOnLabel->labelsize(10);
 editAppRepOnLabel->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
 
 editAppRepDayGroup = new Fl_Group(36,lp[2],124,14);
 editAppRepDayGroup->begin();
 int x =36,dx=17;
 for(int j=0;j<7;j++)
  {
   editAppRepDays[j] = new Fl_Button(x,lp[2],dx,14,weekDaysShort[j]);
   editAppRepDays[j]->labelsize(10);
   editAppRepDays[j]->type(FL_RADIO_BUTTON);
   editAppRepDays[j]->value(0);
   x+=dx;
  }
 editAppRepDayGroup->end();

 
 editAppRepWeekNrLabel = new Fl_Box(36,lp[3],48,14,"in week Number");
 editAppRepWeekNrLabel->box(FL_NO_BOX);
 editAppRepWeekNrLabel->labelsize(10);
 editAppRepWeekNrLabel->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 editAppRepWeekNr = new Fl_Input(116,lp[3],24,14);
 editAppRepWeekNr->labelsize(10);

 editAppRepUntilLabel = new Fl_Box(2,lp[4],34,14,"until");
 editAppRepUntilLabel->box(FL_NO_BOX);
 editAppRepUntilLabel->labelsize(10);
 editAppRepUntilLabel->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 strcpy(repUntilDate,"infinity");
 editAppRepUntil = new Fl_Button(36,lp[4],122,14,repUntilDate);
 editAppRepUntil->labelsize(10);
 editAppRepUntil->callback(editAppSetRepUntilDate);
 
 editAppUpdateRepeatTab(4);

 editAppRepeatGroup ->end();
}

void editAppDoSetRepUntilDate(timeDef sel)
{
 char tx[32];
 
 curRepUntil = sel;
 strftime(repUntilDate,31,"%d.%b.%Y",&curRepUntil.tm);
}
void editAppSetRepUntilDate(Fl_Widget *w)
{
 selectDay(&curRepUntil,editAppDoSetRepUntilDate);
 //editAppRepUntil,repUntilDate,&curRepUntil);
}
void editAppSetRepeatType(Fl_Widget *w, void *dummy)
{
 Fl_Menu_Button *m = (Fl_Menu_Button *) w;
 int type = m->value();
 m->label(repeatTypes[type]);
 m->redraw();
 editAppRepEveryLabel2->label(repeatUnits[type]);
 editAppRepEveryLabel2->redraw();
 editAppUpdateRepeatTab(type);
}
void editAppFillRepeatTab(AppointmentRepeat *ar)
{
 int type = repeatType2[ar->type];
 char txt[64];
 editAppRepeatTypeMenu->label(repeatTypes[type]);
 editAppRepeatTypeMenu->redraw();
 editAppRepEveryLabel2->label(repeatUnits[type]);
 editAppRepEveryLabel2->redraw();
 editAppUpdateRepeatTab(type);
 
 if( type != GUI_REPEAT_TYPE_NONE )
  {
   sprintf(txt,"%d",ar->intervall);
   editAppRepEvery->value(txt);
   editAppRepEvery->redraw();
  }

 if(type == GUI_REPEAT_TYPE_WEEK || type == GUI_REPEAT_TYPE_MONTH_BY_DAY )
  {
   int wd=0x1;
   for(int j=0;j<7;j++)
    {
     if( (ar->dayFlags & wd) > 0)
      editAppRepDays[j]->value(1);
     else
      editAppRepDays[j]->value(0);
     wd = wd<<1;
     editAppRepDays[j]->redraw();
    }
  }

 if(type == GUI_REPEAT_TYPE_MONTH_BY_DAY )
  {
   sprintf(txt,"%d",ar->weekInMonth+1);
   editAppRepWeekNr->value(txt);
   editAppRepWeekNr->redraw();
  }
 if( type != GUI_REPEAT_TYPE_NONE )
  {
   curRepUntil.set(ar->until);
   strftime(repUntilDate,31,"%d.%b.%Y",&curRepUntil.tm);
   editAppRepUntil->redraw();
  }
}
void editAppUpdateRepeatTab(int type)
{
 if(type == GUI_REPEAT_TYPE_NONE )
  {
   editAppRepEveryLabel->labelcolor(FL_GRAY);
   editAppRepEvery->deactivate();
   editAppRepEveryLabel2->labelcolor(FL_GRAY);
   editAppRepUntilLabel->labelcolor(FL_GRAY);
   editAppRepUntil->deactivate();
  }
 else
  {
   editAppRepEveryLabel->labelcolor(FL_BLACK);
   editAppRepEvery->activate();
   editAppRepEveryLabel2->labelcolor(FL_BLACK);
   editAppRepUntilLabel->labelcolor(FL_BLACK);
   editAppRepUntil->activate();
  }
 editAppRepEveryLabel->redraw();
 editAppRepEveryLabel2->redraw();
 editAppRepUntilLabel->redraw();


 if(type == GUI_REPEAT_TYPE_WEEK || type == GUI_REPEAT_TYPE_MONTH_BY_DAY )
  {
   for(int j=0;j<7;j++)
    editAppRepDays[j]->activate();
   if(type == GUI_REPEAT_TYPE_WEEK)
    for(int j=0;j<7;j++)
     editAppRepDays[j]->type(FL_TOGGLE_BUTTON);
   else
    for(int j=0;j<7;j++)
     editAppRepDays[j]->type(FL_RADIO_BUTTON);
   editAppRepOnLabel->labelcolor(FL_BLACK);
  }
 else
  {
   for(int j=0;j<7;j++)
    editAppRepDays[j]->deactivate();
   editAppRepOnLabel->labelcolor(FL_GRAY);
  }

 if(type == GUI_REPEAT_TYPE_MONTH_BY_DAY )
  {
   editAppRepWeekNr->activate();
   editAppRepWeekNrLabel->labelcolor(FL_BLACK);
  }
 else
  {
   editAppRepWeekNr->activate();
   editAppRepWeekNrLabel->labelcolor(FL_GRAY);
  }
 editAppRepWeekNrLabel->redraw();
 editAppRepOnLabel->redraw();

}


// Description Tab
int drawEditDescrTab( ) 
{
 
 editAppDescrGroup ->begin();
 editAppLabelDescr = new Fl_Box(2,46,156,14,"Appointment Description:");
 editAppLabelDescr->box(FL_NO_BOX);
 editAppLabelDescr->labelsize(10);
 editAppLabelDescr->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
 editAppDescr = new Fl_Multiline_Input ( 2,60,156,140);
 editAppDescr->textsize(10);
 editAppDescrGroup ->end();

}

// Menu callbacks
void editAppCancel(Fl_Widget *w)
{
 calWindow->show();
 editAppWindow->hide();
 delete editAppWindow;
 if(findKey[0] == '\0')
  buildCalendar();
 else
  findNextAppointment(-1);
}
void editAppExit(Fl_Widget *w)
{
 if(editAppSaveDate2Current())
  editAppCancel(w);
}


void editAppDelete(Fl_Widget *w)
{
 if(origApp != NULL)
  {
   if(origApp->app->rep.type != REPEAT_TYPE_NONE)
    {
     char txt[64];
     struct tm *lt;
     int ans;
      lt=localtime((const time_t *) &origApp->start);
      strftime(txt,63,"%a, %d.%b.%Y, %H:%M",lt);
      ans =fl_choice("Do you want to remove all of this appointment, or only the current event at %s?","Current","All","Cancel",txt) ;
     if(ans == 0)
      {
       origApp->app->rep.addException(origApp->start);
       editAppCancel(NULL);
      }
     else if(ans == 1)
      {
       cal.remove(origApp->app);
       editAppCancel(NULL);
      }
    }
   else
    {
     if(fl_ask("Do you want to delete this Appointment ?") == 1)
      {
       cal.remove(origApp->app);
       editAppCancel(NULL);
      }
    }
  }
}
void editAppCopy(Fl_Widget *w)
{
}
void editAppCut(Fl_Widget *w)
{
}
void editAppPaste(Fl_Widget *w)
{
}
void editAppInternal(Fl_Widget *w)
{
}
void editAppHelp(Fl_Widget *w)
{
}
void editAppAdvanced(Fl_Widget *w)
{
}
void editAppToggleJournal(Fl_Widget *w)
{
 if(curApp.journal)
  {
   editAppSaveJournalAlarm();
   curApp.journal = false;
   editAppFillEventAlarm();
  }
 else
  {
   editAppSaveEventAlarm();
   curApp.journal = true;
   editAppFillJournalAlarm();
  }
 editAppUpdateJournalState();
}
void editAppUpdateJournalState()
{
 if(!curApp.journal)
  {
   
   for(int i=0; i<4; i++)
    {
     // hide JournalAlarm:
     editAppJournalAlarm[i]->hide();
     editAppDateJournalAlarm[i]->hide();
     // show Event Alarm:
     editAlarmIntervall[i]->show();
     editAppAlarmUnitMenu[i]->show();
    }
   
   editAppRepeatGroup->activate();
   editAppBeginHourPlus->activate();
   editAppBeginHourMinus->activate();
   editAppBegin->activate();
   editAppBeginMinPlus->activate();
   editAppBeginMinMinus->activate();
   editAppEndHourPlus->activate();
   editAppEndHourMinus->activate();
   editAppEnd->activate();
   editAppEndMinPlus->activate();
   editAppEndMinMinus->activate();
   editAppLabelLocation->activate();
   editAppLocationMenu->activate();
   editAppLocationEntry->activate();


   editTBjournal->label("Journal");
  }
 else
  {
   editTBjournal->label("Event");

   for(int i=0; i<4; i++)
    {
     // show JournalAlarm:
     editAppJournalAlarm[i]->show();
     editAppDateJournalAlarm[i]->show();
     // hide Event Alarm:
     editAlarmIntervall[i]->hide();
     editAppAlarmUnitMenu[i]->hide();
    }

   editAppRepeatGroup->deactivate();

   editAppBeginHourPlus->deactivate();
   editAppBeginHourMinus->deactivate();
   editAppBegin->deactivate();
   editAppBeginMinPlus->deactivate();
   editAppBeginMinMinus->deactivate();
   editAppEndHourPlus->deactivate();
   editAppEndHourMinus->deactivate();
   editAppEnd->deactivate();
   editAppEndMinPlus->deactivate();
   editAppEndMinMinus->deactivate();
   editAppLabelLocation->deactivate();
   editAppLocationMenu->deactivate();
   editAppLocationEntry->deactivate();
  }
}





// Internal Info

void editAppShowInternalInfo()
{
 char ctim [64];
 struct tm *lt;
 
 if(curApp.DBkey> 852073200)
  {
   lt = localtime((const time_t *)&curApp.DBkey);
   strftime(ctim,63,"%Y-%m-%d %H:%M",lt);
  }
 else
  strcpy(ctim,"unknown");

 if(curApp.hiddenText != NULL)
  fl_message("Internal and hidden Data:\n  * Internal ID = %5d\n  * Creation date: %s\n  * Hidden Text:\n%s\n",
	     curApp.id,ctim,curApp.hiddenText);
 else
  fl_message("Internal and hidden Data:\n  * Internal ID = %5d\n  * Creation date: %s\n  * No hidden Text\n",
	     curApp.id,ctim);
 
}
