// File: test.cc
//
// Time-stamp: <01-Jun-2003 20:43:15 goetz>
// $Id: $
//
// Copyright (C) 2003 by Rdiger Goetz
//
// Author: Ruediger Goetz
//
// Description: 
// 
//

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <unistd.h>

#define ACAL_GUI_MAIN
#include "calendrian.h"
#include <FL/Fl_Pixmap.H>
#include "xpm.h"
//#include "appointment.h"

void switch2TodayCal(Fl_Widget *w);
void switch2DayCal(Fl_Widget *w);
void switch2MonthCal(Fl_Widget *w);
void switch2WeekCal(Fl_Widget *w);
void doJump2Date(Fl_Widget *w,void *d);
void jump2Date(Fl_Widget *w);
void toggleDisplayPrivate(Fl_Widget *w);
void toggleDisplayHidden(Fl_Widget *w);
void toggleDisplayCanceled(Fl_Widget *w);
void editPrefs(Fl_Widget *w);
void displayHelp(Fl_Widget *w);
void aboutApplication(Fl_Widget *w);
void setCalCategory(Fl_Widget *w,void * cat);
void measureLabelSymbolUp (const Fl_Label *label, int &w, int &h);
void measureLabelSymbolDown (const Fl_Label *label, int &w, int &h);
void drawLabelSymbolUp(const Fl_Label *label, int x, int y, int w, int h, Fl_Align align);
void drawLabelSymbolDown(const Fl_Label *label, int x, int y, int w, int h, Fl_Align align);
void fillMainMenuCategoriesMenu();

void exitAcal(Fl_Widget *w,void *d);
void createToolBars();
void createMenu();
void splashScreen();
void start(void *d);
int  doAlarm();
int  testAlarm();

Fl_App_Window *calWindow;
Fl_Dockable_Window *mainTB=NULL;
//Fl_Dockable_Window *dayCalTopTB=NULL;
ToolBar *topTB = NULL;

Fl_Group  *mainCalMenu=NULL;
//Fl_Group  *activeCal =NULL;
Fl_Paged_Scroll *activeCal;
Fl_Menu_Button *mainTBeditMenu,*mainTBviewMenu, *mainTBcatMenu;
Fl_Button *mainTBdone,*mainTBnew;
// Fl_Page_UpDown_Button *mainTBdayCalPageButton =NULL;
// Fl_Page_UpDown_Button *mainTBmonthCalPageButton =NULL;
Fl_Page_UpDown_Button *mainTBpageButton =NULL;
static Fl_Menu_Item mainMenuEditMenuItems [] = {
 { "New Appointment",0,(Fl_Callback *) newApp          ,(void *) 0},
 { "Find Appointment(s)",0,(Fl_Callback *) findAppointments ,(void *) 0,FL_MENU_DIVIDER},
 { "Preferences",     0,(Fl_Callback *) drawPrefsWindow ,(void *) 0,FL_MENU_DIVIDER},
 { "Help",            0,(Fl_Callback *) displayHelp     ,(void *) 0,FL_MENU_INACTIVE|FL_MENU_DIVIDER},
 { "About",           0,(Fl_Callback *) aboutApplication,(void *) 0},
 {0}
};
static Fl_Menu_Item mainMenuViewMenuItems [] = {
{ "Today",          0,(Fl_Callback *) switch2TodayCal  },
{ "Day Calendar",   0,(Fl_Callback *) switch2DayCal   ,(void *) 0},
{ "Week Calendar",  0,(Fl_Callback *) switch2WeekCal  ,(void *) 0,FL_MENU_INACTIVE},
{ "Month Calendar", 0,(Fl_Callback *) switch2MonthCal ,(void *) 0},
{ "Jump to Date",   0,(Fl_Callback *) jump2Date       ,(void *) 0,FL_MENU_DIVIDER},
{ "Show private",   0,(Fl_Callback *) toggleDisplayPrivate ,(void *) 0,FL_MENU_TOGGLE},
{ "Show hidden",    0,(Fl_Callback *) toggleDisplayHidden  ,(void *) 0,FL_MENU_TOGGLE},
{ "Show canceled",  0,(Fl_Callback *) toggleDisplayCanceled,(void *) 0,FL_MENU_TOGGLE},
{0}
};


static  Fl_App_Window *splash;


Calendar cal;
CalendarFilter calFilter;
timeDef currentDate;
char progPath[256];

int currentCalView=DAY_CAL;
int currentCalTopTB=0   ;
// int kernStart=8;
// int kernEnd=20;

int showPrivate =true;
int showHidden =false;
int showCancaled =false;
int updateAlarm=false;

FILE *fpl;

int main(int argc, char **argv) 
{
 char tmp[PATH_MAX];
 char *progName;

 sprintf(tmp,"/proc/%d/exe",getpid());
 readlink(tmp,progPath,255);

 progName=strrchr(argv[0],'/');
 if(progName != NULL)
  progName++;
 else
  progName=argv[0];

 findKey =  new char [4];
 findKey[0]='\0';
 printf("%s -> %s -> %s\n",argv[0],tmp,progPath);
 //printf("DISPLAY: %s, USER=%s, prog=%s -> %s\n",getenv("DISPLAY"),getenv("USER"),argv[0],progPath);
//  printf("uid=%d/%d gid=%d\n",getuid(),geteuid(),getgid());
 //strcpy(progPath,argv[0]);
 
 if(strcmp(progName,"calendrianAlarm")==0)
  {
   testAlarm();
   exit(0);
  }

 if(argc >1)
  {
   if(strcmp(argv[1],"-alarm")==0)
    {
     sleep(5);
     doAlarm();
     exit(0);
    }
   if(strcmp(argv[1],"-test")==0)
    {
     testAlarm();
     exit(0);
    }
   if(strcmp(argv[1],"-update")==0)
    {
     updateAlarm=true;
    }
  }

 splashScreen();
#ifdef VR3
 usleep(100000);
#endif
 return Fl::run();
}

void splashScreen()
{

 splash = WidgetFactory::new_window("Calendrian");
 splash->begin();
 splash->color(FL_WHITE);

 Fl_Box *img   = new Fl_Box(44,10,64,64);
 img->color(FL_WHITE);
 
 Fl_Pixmap *pixmap = new Fl_Pixmap( calendrian_xpm);
 pixmap->label(img);

 Fl_Box *text0 = new Fl_Box(0,80 ,160,24,"Calendrian");
 text0->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
 text0->labelsize(20);
 Fl_Box *text1 = new Fl_Box(20,104,120,16,"Fast, Enhanced");
 text1->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
 text1->labelsize(12);
//  Fl_Box *text2 = new Fl_Box(40,112 ,60,16,"Enhanced");
//  text2->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
//  text2->labelsize(12);
 Fl_Box *text3 = new Fl_Box(20,118,120,16,"Calender");
 text3->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
 text3->labelsize(12);
 Fl_Box *text4 = new Fl_Box(20,132,120,16,"for Agenda VR3");
 text4->align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
 text4->labelsize(12);
 Fl_Box *text5 = new Fl_Box(4,150,60,16,"(c) 2003 by Rdiger Goetz");
 text5->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
 text5->labelsize(8);

 splash ->end();
 splash->show();
#ifdef VR3
 Fl::add_timeout(1.0, start);
#else
 Fl::add_timeout(1.0, start);
#endif
}

void start(void *d)
{
#ifndef VR3
 fpl=fopen("acal.log","w");
#endif
 readDB("./schedule.dat");
 checkAlarmDB();
 if(updateAlarm)
  {
   cal.updateAlarm();
   startAtJob();
  }
 loadPrefs();
 
 currentCalView = 0;
 currentDate.set(time(NULL));

 Fl::set_boxtype(DAYCAL_BOX, drawDayCalBox, 1, 1, 2, 2);
 Fl::set_labeltype(CAL_UP_LABEL,   drawLabelSymbolUp, measureLabelSymbolUp);

 calWindow =   WidgetFactory::new_window("Calendrian");
 calWindow->resizable(calWindow);

 createToolBars();
 buildCalendar(defCalView);

 calWindow->end();
 calWindow->show();
 
#ifdef VR3
 usleep(500000);
#endif
 splash->hide();
 delete splash;
}

void createToolBars()
{
 if(mainTB == NULL)
  {
   mainTB =  WidgetFactory::new_toolbar();
   mainTB->begin();
   
   mainTBdone = WidgetFactory::new_button("");
   mainTBdone->label("Done");
   mainTBdone->resize(0,0,32,16);
   mainTBdone->callback(exitAcal);
   mainTBdone->show();
   
   mainTBeditMenu = WidgetFactory::new_menu_button("");
   mainTBeditMenu->label("Edit");
   mainTBeditMenu->resize(32,0,32,16);
   mainTBeditMenu->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
   mainTBeditMenu->menu(mainMenuEditMenuItems);
   mainTBeditMenu->show();

   mainTBviewMenu= WidgetFactory::new_menu_button("");
   mainTBviewMenu->label("View");
   mainTBviewMenu->resize(64,0,32,16);
   mainTBviewMenu->menu(mainMenuViewMenuItems);
   mainTBviewMenu->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
   mainTBviewMenu->show();

   for(int i=0;i<8; i++)
    mainMenuViewMenuItems[5].labelsize(10);

   if(calFilter.showPrivate)
    mainMenuViewMenuItems[5].set();
   else
    mainMenuViewMenuItems[5].clear();
   mainMenuViewMenuItems[5].callback(toggleDisplayPrivate);
   if(calFilter.showHidden)
    mainMenuViewMenuItems[6].set();
   else
    mainMenuViewMenuItems[6].clear();
   mainMenuViewMenuItems[6].callback(toggleDisplayHidden);
   if(calFilter.showCanceled)
    mainMenuViewMenuItems[7].set();
   else
    mainMenuViewMenuItems[7].clear();
   mainMenuViewMenuItems[7].callback(toggleDisplayCanceled);
   
   
   mainTBcatMenu= WidgetFactory::new_menu_button("");
   mainTBcatMenu->label("All");
   mainTBcatMenu->resize(96,0,56,16);
   mainTBcatMenu->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
   mainTBcatMenu->show();

   mainTBcatMenu->add("All",0,(Fl_Callback *) setCalCategory,(void *) -1);
   fillMainMenuCategoriesMenu();
   
   mainTBpageButton = WidgetFactory::new_pagekey();
   mainTBpageButton->resize(152,0,8,16);

   mainTB->end();
   calWindow->add_dockable(mainTB,1);
  }
 if(topTB == NULL)
  {
   topTB = new ToolBar;
   calWindow->add_dockable(topTB,0);
  }
}

void fillMainMenuCategoriesMenu()
{
 int last=-1;
 int c=0;

 mainTBcatMenu->clear();

 for(int i=0;i<MAX_CATEGORIES; i++) 
  if(categories[i]!=NULL)
   {
    mainTBcatMenu->add(categories[i],0,(Fl_Callback *) setCategory,(void *) i);
    mainTBcatMenu->textsize(10);
    last=c;
    c++;
   }
 mainTBcatMenu->mode(last,FL_MENU_DIVIDER  );
 mainTBcatMenu->mode(last,FL_MENU_DIVIDER  );
 mainTBcatMenu->add("Edit Categories",0,(Fl_Callback *) editCategories,(void *)fillMainMenuCategoriesMenu);
 mainTBcatMenu->textsize(10);
 mainTBcatMenu->redraw();
}



void clearActiveCal()
{
 if(activeCal != NULL)
  {
   calWindow->contents()->remove(activeCal);
   delete activeCal;
   activeCal = NULL;
  }

 if(activeCal == NULL)
  {
   int h = calWindow->h();
   activeCal =new Fl_Paged_Scroll(0, 0, 160, h - 2*WidgetFactory::buttonheight());
   activeCal->page_updown_button(mainTBpageButton);
  }
 else
  activeCal->clear();

 activeCal->box(FL_FLAT_BOX);
 activeCal->color(FL_WHITE);
 calWindow->add(activeCal);
 calWindow->redraw();
}

void buildCalendar( int typ)
{
 
 if(currentCalView != typ)
  if(topTB != NULL)
    topTB->clear();


 currentCalView=typ;
 buildCalendar();
}
void buildCalendar()
{
 // printf("rebuild Cal\n");
 switch(currentCalView)
  {
  case DAY_CAL: 
   drawDayCalWindow();
   break;
  case WEEK_CAL: 
   //   drawWeekCalWindow()
   break;
  case MONTH_CAL: 
   drawMonthCalWindow();
   break;
  }
}

void exitAcal(Fl_Widget *w,void *d)
{
 exit(0);
}
void newApp(Fl_Widget *w,void *l)
{
 timeDef start;
 Fl_Box * b = (Fl_Box *) w;
 char lab[64],*t=NULL;

 
 start = currentDate;
 if( l != NULL)
  {
   strncpy(lab,(char *)l,63);
   t=strchr(lab,':');

  }

 if( t != NULL)
  {
   *t='\0';
   start.hour = atoi(lab);
   t++;
   start.min = atoi(t);
   start.sec = 0;
   start.set();
   editAppointment(&start);
  }
 else 
  editAppointment((timeDef *) NULL);
}




void setCalCategory(Fl_Widget *w,void * cat)
{
 int l=(int ) cat;
 if(l <0)
  {
   w->label("All");
   calFilter.showCategory = -1;
  }
 else
  {
   w->label(categories[l]);
   calFilter.showCategory = l;
  }
 w->redraw();

 // printf("\n\n\n\nrebuildCalendar %d\n",currentCalView);
 buildCalendar();
}



void switch2TodayCal(Fl_Widget *w)
{
 currentDate.set(time(NULL));
 buildCalendar(DAY_CAL);
 // drawDayCalWindow();
}
void switch2DayCal(Fl_Widget *w)
{
 buildCalendar(DAY_CAL);
 // drawDayCalWindow();
}
void switch2MonthCal(Fl_Widget *w)
{
 buildCalendar(MONTH_CAL);
 
 // drawMonthCalWindow();
}
void switch2WeekCal(Fl_Widget *w)
{
 // buildCalendar(WEEK_CAL);
 // drawWeekCalWindow();
}

void doJump2Date(timeDef sel )
{
 currentDate =sel;
 buildCalendar();
}
void jump2Date(Fl_Widget *w)
{
 selectDay(&currentDate,doJump2Date);
}

void toggleDisplayPrivate(Fl_Widget *w)
{
 Fl_Menu_Item *m = &mainMenuViewMenuItems[5];

 if(m->value() > 0)
  calFilter.showPrivate = true;
 else
  calFilter.showPrivate = false;
 buildCalendar();
}
void toggleDisplayHidden(Fl_Widget *w)
{
 Fl_Menu_Item *m = &mainMenuViewMenuItems[6];

 if(m->value() >0)
  calFilter.showHidden = true;
 else
  calFilter.showHidden = false;
 buildCalendar();
}
void toggleDisplayCanceled(Fl_Widget *w)
{
 Fl_Menu_Item *m = &mainMenuViewMenuItems[7];

 if(m->value() >0)
  calFilter.showCanceled = true;
 else
  calFilter.showCanceled = false;
 buildCalendar();
}
void editPrefs(Fl_Widget *w)
{
}
void displayHelp(Fl_Widget *w)
{
}
void aboutApplication(Fl_Widget *w)
{
 fl_message("Calendrian 0.24.1\nNew Calendar Application\n for Agenda VR3\n(c) by Rdiger Goetz 2003");
}







void measureLabelSymbolUp (const Fl_Label *label, int &w, int &h)
{
 w=0;
 h=0;
}

void drawLabelSymbolUp(const Fl_Label *label, int x, int y, int w, int h, Fl_Align align)
{
 int x0,x1,x2,ox;
 int y0,y1,oy;
 int d=w;
 if (d > h)
  {
   d=h;
   oy =0;
   ox = (w-d)/2;
  }
 else
  {
   ox =0;
   oy = (h-d)/2;
  }

 y0 = ox + y+1;
 y1 = ox + y+d-1;

 x0 = ox +x;
 x1 = ox +x+d/2;
 x2 = ox +x+d;

//  printf("x=%3d y=%3d w=%3d h=%3d -> d=%3d\n",x,y,w,h,d);
//  printf("\t-> X=%3d %3d %3d // Y=%3d %3d\n",x0,x1,x2,y0,y1);

 fl_color(FL_BLACK);
 if(label->value[0] == '+' ) 
  fl_polygon(x0,y1,x1,y0,x2,y1,x0,y1);
 else if  (label->value[0] == '-' ) 
  fl_polygon(x0,y0,x1,y1,x2,y0,x0,y0);
}

