/* File: acal_gui.h
 *
 * Time-stamp: <28-May-2003 20:07:37 goetz>
 * $Id: $
 *
 * Copyright (C) 2003 by Rdiger Goetz
 *
 * Author: Ruediger Goetz
 *
 * Description: 
 * 
 */
# ifndef ACAL_GUI_H_INCLUDED
# define ACAL_GUI_H_INCLUDED

#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Multiline_Input.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Menu_Button.H>
#include <FL/Fl_Round_Button.H>
#include <FL/fl_draw.H>
#include <FL/Fl_Tabs.H>
#include <FL/fl_message.H>
#include <flpda/Widget_Factory.h>
#include <flpda/Fl_Paged_Scroll.H>
#include <Flek/Fl_Dockable_Window.H>
//#include <FL/Fl_Select_Browser.H>


#define DAYCAL_BOX FL_FREE_BOXTYPE
#define CAL_UP_LABEL FL_FREE_LABELTYPE
#define CAL_DOWN_LABEL FL_FREE_LABELTYPE+1




#define GUI_REPEAT_TYPE_NONE    0
#define GUI_REPEAT_TYPE_DAY     1
#define GUI_REPEAT_TYPE_WEEK    2
#define GUI_REPEAT_TYPE_MONTH   3
#define GUI_REPEAT_TYPE_MONTH_BY_DAY 4
#define GUI_REPEAT_TYPE_YEAR    5

typedef void (SelectDateCallBack)(timeDef); 
typedef void (UsedDatesCallBack)(timeDef *,int *); 
typedef  void(VoidFunction)(void);


class ToolBar : public Fl_Dockable_Window
{
public:
 ToolBar(const char *l = 0) : Fl_Dockable_Window(160,16,l) 
 {
  grippertype(0);
  Fl_Pack* p = new Fl_Pack(0, 0, 160, 16, 0);
  p->type(Fl_Pack::HORIZONTAL);
  ;
 }
 ToolBar(int w, int h, const char *l = 0) : Fl_Dockable_Window(w,h,l) 
 {
  grippertype(0);
  Fl_Pack* p = new Fl_Pack(0, 0, 160, 16, 0);
  p->type(Fl_Pack::HORIZONTAL);
  ;
 }
 ToolBar(int x, int y, int w, int h, const char *l = 0) : Fl_Dockable_Window(x,y,w,h,l)
 {
  grippertype(0);
  Fl_Pack* p = new Fl_Pack(0, 0, 160, 16, 0);
  p->type(Fl_Pack::HORIZONTAL);
  ;
 }

//  Fl_Window * toolbar()
//  {
//   return contents;
//  }
 void clear ()
 {
  contents->clear();
  contents->redraw();
 }
};


#ifdef ACAL_GUI_MAIN


char *stati[8]={"normal","private","hidden","hidden + private","canceled","canceled+private","canceled+hidden","canceled+hidden+private"};
char *timeUnits[6]={"minutes","hours","days","weeks","month","years"};
char *timeUnitsShort[6]={"m","h","D","W","M","Y"};
long int   timeUnitMax[6]={999,59940,1438560,10069920,43156800,525074400};
long int   timeUnitMin[6]={1,60,1440,10080,43200,525600};
char *repeatTypes[6]={"none","day","week","month (by date)","month (by day)","year"};
int repeatType2[6]={0,1,2,3,5,4};
char *repeatUnits[6]={"","day(s)","week(s)","month","month","year(s)"};
char *weekDaysShort[7]={"Mo","Tu","We","Th","Fr","Sa","Su"};
#else
extern char *stati[8];
extern char *timeUnits[6];
extern char *timeUnitsShort[6];
extern long int   timeUnitMax[6];
extern long int   timeUnitMin[6];
extern char *repeatTypes[6]; 
extern int repeatType2[6];
extern char *repeatUnits[6]; 
extern char *weekDaysShort[7];
#endif

extern char *categories[MAX_CATEGORIES];
extern char *locations[MAX_LOCATION];
extern char *findKey;


extern FILE *fpl;

extern Fl_App_Window *calWindow, *editWindow;
extern Fl_App_Window * prefWin;

//extern Fl_Dockable_Window *calMenu;
//extern Fl_Dockable_Window *dayCalTopTB;
extern ToolBar *topTB;
extern Fl_Page_UpDown_Button *mainTBpageButton;
//extern Fl_Group *activeCal;
extern Fl_Paged_Scroll *activeCal;
extern Fl_Group *mainCalMenu;
extern Fl_Menu_Button *mainTBviewMenu, *mainTBcatMenu;
extern Fl_Menu_Button *editTBeditMenu, *editTBcatMenu;
extern Fl_Button *mainTBdone,*mainTBnew;
extern Fl_Button *editTBDone,*editTBjournal;
extern CalendarFilter calFilter;

extern timeDef currentDate;
extern int currentCalView;
//extern int previousCalView;
extern int currentCalTopTB;

int compareInts(const void *v1, const void *v2);
void drawDayCalBox(int x, int y, int w, int h, Fl_Color c);
 
void editAppointment(Fl_Widget *w, void *a );
void editAppointment(timeDef *start);
void editAppointment(Appointment *app);
int  drawEditAppointment( );
void editAppFill(AppointmentInstance *app,timeDef *start=0);
void editLocation(Fl_Widget *w,void *d=0);
//void editLocation(void);
void editCategories(Fl_Widget *w, void *f);
void setCategory(Fl_Widget *w,void *loc);
void editAppFillLocationsMenu();
void editAppFillCategoriesMenu();
void drawDayCalWindow();
void drawMonthCalWindow();
void drawMainMenu();
//void hideMenu();
//void selectDay(Fl_Button *w, char *str,timeDef *date);
void selectDay ( timeDef *mon, SelectDateCallBack *sel);
 //void selectDay(Fl_Callback *fkt,timeDef *date);
//void drawMonthView(timeDef *month,Fl_Callback *fkt);

void buildCalendar(int typ);
void buildCalendar();
void newApp(Fl_Widget *w,void *d=0);
void clearActiveCal();
Fl_Dockable_Window * drawMonthViewTopTB (Fl_App_Window *w,int pos);

void findAppointments(Fl_Widget *w);
int  findNextAppointment(int start);
void updateAndStartAtJob();

void drawPrefsWindow(Fl_Widget *w,void *);
//void readDB(char *file);

# endif
