/* File: monthView.h
 *
 * Time-stamp: <12-May-2003 22:27:43 goetz>
 * $Id: $
 *
 * Copyright (C) 2003 by Rdiger Goetz
 *
 * Author: me
 *
 * Description: 
 * 
 */
# ifndef MONTHVIEW_H_INCLUDED
# define MONTHVIEW_H_INCLUDED


class MonthView
{
public:
 // Fl_Dockable_Window *topTB;
 ToolBar *topTB;
 Fl_Button *yearMinus,*monMinus,*curMonth;
 Fl_Button *monPlus,*yearPlus;
 Fl_Button *dateButtons[32],*buttons[42];
 Fl_Button *weekDay[7];
 timeDef month;
 char curMonText[32],dateButtonText[32][4];
 UsedDatesCallBack *cb_used;
 SelectDateCallBack *cb_select;


 MonthView()
 {
  topTB = NULL;
  yearMinus=NULL;
  monMinus=NULL;
  curMonth=NULL;
  monPlus=NULL;
  yearPlus=NULL;
  for (int i=0;i<32; i++)
  dateButtons[i]=NULL;
  for (int i=0;i<42; i++)
   buttons[i]=NULL;
  for (int i=0;i<7; i++)
   weekDay[i]=NULL;
  cb_used=NULL;
  cb_select=NULL;
 }
 ~MonthView()             // let the upper window remove the widgets
 {
  topTB = NULL;
  yearMinus=NULL;
  monMinus=NULL;
  curMonth=NULL;
  monPlus=NULL;
  yearPlus=NULL;
  for (int i=0;i<32; i++)
   dateButtons[i]=NULL;
  for (int i=0;i<42; i++)
   buttons[i]=NULL;
  for (int i=0;i<7; i++)
   weekDay[i]=NULL;
  cb_used=NULL;
  cb_select=NULL;
 }

 void init ( timeDef *mon, UsedDatesCallBack *fmcb, SelectDateCallBack *sel)
 {
  cb_used   = fmcb;
  cb_select = sel;
  month     = mon;
  month.day = 1;
  month.set();
 }

 static void prvYear(Fl_Widget *w,void *d)
 {
  MonthView *mv = (MonthView *) d;
  mv->month.skip2PrevYear();
  mv->month.set(); 
  mv->fill();
 }
 static void nxtYear(Fl_Widget *w,void *d)
 {
  MonthView *mv = (MonthView *) d;
  mv->month.skip2NextYear();
  mv->month.set(); 
  mv->fill();
 }
 static void prvMon(Fl_Widget *w,void *d)
 {
  MonthView *mv = (MonthView *) d;
  mv->month.skip2PrevMonth();
  mv->month.set(); 
  mv->fill();
 }
 static void nxtMon(Fl_Widget *w,void *d)
 {
  MonthView *mv = (MonthView *) d;
  mv->month.skip2NextMonth();
  mv->month.set(); 
  mv->fill();
 }
 static void nothing(Fl_Widget *w, void *d=0)
 {
 }
 static void select(Fl_Widget *w, void *d=0)
 {
  Fl_Button *m = (Fl_Button *) w;
  const char *t = m->label();
  MonthView *mv = (MonthView *) d;
  timeDef sel;
  // FIXME day
  if(mv->cb_select != NULL)
   {
    sel = mv->month;
    sel.day = atoi(t);
    mv->cb_select(sel);
   }
 }
 void createTB (Fl_App_Window *w)
 {
  //  topTB= WidgetFactory::new_toolbar();
  topTB = new ToolBar;
  fillTB(topTB);
  
  w->add_dockable(topTB,0);
 }
 void fillTB (ToolBar *w)
 {  
  if(topTB == NULL)
   topTB=w;

  topTB->begin();
  yearMinus = new Fl_Button (0,0,24,16,"@<<");
  yearMinus->callback(MonthView::prvYear,(void *) this);
  yearMinus->labelsize(12);
  yearMinus->labeltype(FL_SYMBOL_LABEL);

  monMinus = new Fl_Button (24,0,24,16,"@<");
  monMinus->callback(MonthView::prvMon,(void *) this);
  monMinus->labelsize(12);
  monMinus->labeltype(FL_SYMBOL_LABEL);
  monMinus->shortcut(FL_Left);
  
  curMonth = new Fl_Button (48,0,64,16,"");
  curMonth->labelsize(12);
  curMonth->labelfont(FL_HELVETICA_BOLD);
  
  monPlus = new Fl_Button (112,0,24,16,"@>");
  monPlus->callback(MonthView::nxtMon,(void *) this);
  monPlus->labelsize(12);
  monPlus->labeltype(FL_SYMBOL_LABEL);
  monPlus->shortcut(FL_Right);

  yearPlus = new Fl_Button (136,0,24,16,"@>>");
  yearPlus->callback(MonthView::nxtYear,(void *) this);
  yearPlus->labelsize(12);
  yearPlus->labeltype(FL_SYMBOL_LABEL);

  topTB->end();
 }

 void undockTB(Fl_App_Window *w)
 {
  w->contents()->remove(topTB);
  topTB->undock();
  topTB->hide();
 }
 void redockTB(Fl_App_Window *w)
 {
  w->add_dockable(topTB,0);
  topTB->show();
  w->redraw();
 }

 void createCal ()
 {
  int lp[8]={2,14,34,54, 74, 94,114,134};
  int x,y;
  
  x=10;
  for(int i=0;i<7;i++)
   {
    weekDay[i] = new Fl_Button(x,lp[1],20,20,weekDaysShort[i]);
    weekDay[i]->labelsize(12);
    x+=20;
   }
  
  int i=0;
  for(int y=2; y<8; y++)
   for(int x=10;x <131; x+=20)
    {
     //    Buttons[i] =  new  Fl_Button (x,lp[y],22,22);
     buttons[i] =  WidgetFactory::new_button(x,lp[y]);
     buttons[i]->size(20,20);
     buttons[i]->labelsize(12);
     buttons[i]->redraw();
     //     printf("add button %d\n",i);
     i++;
    }
  
  for(int i=1;i<=31; i++)
   sprintf(dateButtonText[i],"%2d",i );
 }
 
 
 void fill()
 {
  int off,extra=0;
  int used[33];


  
  for(int i=0;i<42; i++)
   buttons[i]->label("");
  
  strftime(curMonText,31,"%b %Y",&month.tm);
  curMonth->label(curMonText);
  curMonth->redraw();

  //  printf("fill MV for %s\n",curMonText);
  
  if(month.mon==2)
   if( (month.year %4 )  == 0)
    extra =1;
  
  off = month.wday;
  
  //  printf("fill MV for %d in %d\n",monLen[month.mon]+extra,month.mon);
  for(int i=0; i<monLen[month.mon]+extra ; i++)
   {
    dateButtons[i+1] = buttons[i+off];
    dateButtons[i+1]->label(dateButtonText[i+1]);
    dateButtons[i+1]->callback(MonthView::select,(void *) this);
    dateButtons[i+1]->redraw();
    //    printf("date %d\n",i+1);
   }
  
  for(int i=0;i<35; i++)
   buttons[i]->redraw();
  if(monLen[month.mon]+extra+off <=35)
   for(int i=35;i<42; i++)
    buttons[i]->hide();
  else
   for(int i=35;i<42; i++)
    {
     buttons[i]->show();
     buttons[i]->redraw();
    }
  
  if(cb_used != 0)
   {
    cb_used(&month,used);
    for(int i=1;i<=31; i++)
     if(dateButtons[i] != NULL)
      {
       if(used[i])
	dateButtons[i]->labelfont(FL_HELVETICA_BOLD);
       else
	dateButtons[i]->labelfont(FL_HELVETICA);
      }
   }
 }

 
};


extern MonthView *monthCalView;

# endif
