// File: prefs.cc
//
// Time-stamp: <28-May-2003 21:05:03 goetz>
// $Id: $
//
// Copyright (C) 2003 by Rdiger Goetz
//
// Author: me
//
// Description: 
// 
//

# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <unistd.h>

#include "calendrian.h"



int kernStart=8, kernEnd=20;
char * locations[MAX_LOCATION];
int defCalView=DAY_CAL;
int language=LANG_EN;
int alarmRepeat=6,alarmRepeatIntervall=10;
int defaultCat=0;
 char *categories[MAX_CATEGORIES];

char *nextValue(char *t)
{
 while(*t != ' ' && *t != '\t' && *t != '\0')
  t++;
 while(*t == ' ' || *t == '\t')
  t++;
 return(t);
}

void loadPrefs()
{
 FILE *fp;
 char str[256],*t,*s;
 int locationCount=1;

 for(int i=0;i<MAX_LOCATION; i++)
  locations[i]=NULL;

 categories[0] = "Other";
 // locations[0] = "Other";
 defCalView =1;

 sprintf(str,"%s/.calendrian",getenv("HOME"));
 fp = fopen(str,"r");
 
 if(fp!=NULL)
  {
   while(fgets(str,255,fp) != NULL)
    {
     if(strncmp(str,"VIEW ",5) == 0)
      {
       t = nextValue(str+4);
       s = t +strlen(t)-1;
       while ((*s == '\0' || *s == ' ' || *s == '\t' || *s == '\n') && s>t)
	{
	 *s ='\0';
	 s--;
	}

       if(strcasecmp(t,"day")== 0)
	defCalView = DAY_CAL;
       else if(strcasecmp(t,"week")== 0)
	defCalView = WEEK_CAL;
       else if(strcasecmp(t,"month")== 0)
	defCalView = MONTH_CAL;
      }
     else if(strncmp(str,"LANGUAGE ",9) == 0)
      {
       t = nextValue(str+8);
       language = LANG_EN;
       if(strcasecmp(t,"en")== 0)
	language = LANG_EN;
       else if(strcasecmp(t,"de")== 0)
	language = LANG_DE;
      }
     else if(strncmp(str,"ALARM_REPEAT ",13) == 0)
      {
       t = nextValue(str+8);
       alarmRepeat = atoi(t);
       t = nextValue(t);
       alarmRepeatIntervall =atoi(t);
       if(alarmRepeat<=0)
	alarmRepeat =1;
       if(alarmRepeatIntervall<=10)
	alarmRepeatIntervall =10;
      }
     else if(strncmp(str,"CORETIME ",9) == 0)
      {
       t = nextValue(str+8);
       kernStart = atoi(t);
       if(kernStart <0 || kernStart>23)
	kernStart=8;
       t = nextValue(t);
       kernEnd =atoi(t);
       if(kernEnd <0 || kernEnd>23)
	kernEnd=20;
       if(kernEnd <= kernStart)
	kernEnd = kernStart+1;
      }
     else if(strncmp(str,"CATEGORY ",9) == 0)
      {
       t = nextValue(str+8);
       for(int i=0;i<MAX_CATEGORIES; i++)
	if(categories[i] != NULL)
	 if(strcmp(categories[i],t)==0)
	  {
	   defaultCat=i;
	   break;
	  }      
      }
     else if(strncmp(str,"LOCATION ",9) == 0)     
      {
       int add=true;
       t = nextValue(str+8);
       s = t +strlen(t)-1;
       while ((*s == '\0' || *s == ' ' || *s == '\t' || *s == '\n') && s>t)
	{
	 *s ='\0';
	 s--;
	}
       for(int i=0;i<MAX_LOCATION; i++)
	if(locations[i]!=NULL)
	 if(strcmp(locations[i],t)==0)
	  {
	   add=false;
	   break;
	  }      
       if(add)
	{
	 str[255]='\0';
	 addLocation(locationCount,t);
	 locationCount++;
	}
      }
    }
   fclose(fp);
  }
}

void savePrefs()
{
 char str[256];
 FILE *fp;
 sprintf(str,"%s/.calendrian",getenv("HOME"));
 fp = fopen(str,"w");

 if(fp!=NULL)
  {
   switch (defCalView)
    {
    case MONTH_CAL: fprintf(fp,"VIEW month\n"); break;
    case WEEK_CAL:  fprintf(fp,"VIEW week\n"); break;
    case DAY_CAL:
    default:
     fprintf(fp,"VIEW day\n"); break;
    }

    switch (language)
    {
    case LANG_DE: fprintf(fp,"LANGUAGE de\n"); break;
    case LANG_EN:
    default:
     fprintf(fp,"LANGUAGE en\n"); break;
    }

    fprintf(fp,"ALARM_REPEAT %d %d\n",alarmRepeat,alarmRepeatIntervall);
    fprintf(fp,"CORETIME %d %d\n",kernStart,kernEnd);
    if(categories[defaultCat] != NULL)
     fprintf(fp,"CATEGORY %s\n",categories[defaultCat]);
    else
     fprintf(fp,"CATEGORY Other\n");
    
     for(int i=0;i<MAX_LOCATION; i++)
      if(locations[i]!=NULL)
       fprintf(fp,"LOCATION %s\n",locations[i]);
  }
 fclose(fp);
}


Fl_App_Window * prefWin = NULL;
Fl_Dockable_Window *prefTB;
static Fl_Menu_Button *calType,*languageMenu,*defCatMenu;
static Fl_Input *alarmRepCountInput, *alarmRepIntervallInput,*coreStart,*coreEnd;
static char countStr[8],intervallStr[8],coreStartStr[8],coreEndStr[8];
void prefFillCatMenu (Fl_Widget *w);
void fillPrefWindow();
void exitPref(Fl_Widget *w);
void cancelPref(Fl_Widget *w);
void closePref();
void prefFillCalType();
void prefSetDayCal(Fl_Widget *w,void *);
void prefSetWeekCal(Fl_Widget *w,void *);
void prefSetMonthCal(Fl_Widget *w,void *);
void prefSetCategory(Fl_Widget *w,void * cat);


void drawPrefsWindow (Fl_Widget *w,void *)
{
 int lp[]= {2,18,38,58,74,94,114,134};

 prefWin = WidgetFactory::new_window("Calendrian");

 prefTB =  WidgetFactory::new_toolbar();
 prefTB->begin();
 
 Fl_Button * prefTBdone = WidgetFactory::new_button("");
 prefTBdone->label("Done");
 prefTBdone->resize(0,0,40,16);
 prefTBdone->callback(exitPref);
 prefTBdone->show();
 
 Fl_Button * prefTBcancel = WidgetFactory::new_button("");
 prefTBcancel->label("Cancel");
 prefTBcancel->resize(40,0,40,16);
 prefTBcancel->callback(cancelPref);
 prefTBcancel->show();

 prefTB->end();

 prefWin->add_dockable(prefTB,1);



 prefWin->begin();
 Fl_Box *calTypeLabel = new Fl_Box(0,lp[0],80,14,"Prefered ");
 calTypeLabel->labelsize(10);
 calTypeLabel->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
 Fl_Box *calTypeLabel2 = new Fl_Box(2,lp[1],80,14,"Calendar Type");
 calTypeLabel2->labelsize(10);
 calTypeLabel2->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
 
 calType = new Fl_Menu_Button(76,lp[1],82,16);
 calType->add("Day Calendar",0,prefSetDayCal);
 calType->add("Week Calendar",0,prefSetWeekCal,0,FL_MENU_INACTIVE);
 calType->add("Month Calendar",0,prefSetMonthCal);
 calType->textsize(10);
 calType->labelsize(10);

 Fl_Box *languageLabel = new Fl_Box(0,lp[2],80,16,"Language");
 languageLabel->labelsize(10);
 languageLabel->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
 
 languageMenu = new Fl_Menu_Button(76,lp[2],82,16);
 languageMenu->add("en",0,prefSetDayCal);
 languageMenu->textsize(10);
 languageMenu->labelsize(10);

 Fl_Box *alarmRepLabel = new Fl_Box(0,lp[3],80,16,"Alarm Repition");
 alarmRepLabel->labelsize(10);
 alarmRepLabel->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 
 alarmRepCountInput = new Fl_Input(36,lp[4],24,16);
 alarmRepCountInput->textsize(10);

 Fl_Box *alarmRepLabel2 = new Fl_Box(59,lp[4],54,16,"times every");
 alarmRepLabel2->labelsize(10);
 alarmRepLabel2->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 alarmRepIntervallInput = new Fl_Input(116,lp[4],36,16);
 alarmRepIntervallInput ->textsize(10);

 Fl_Box *alarmRepLabel3 = new Fl_Box(154,lp[4],6,16,"s");
 alarmRepLabel3->labelsize(10);
 alarmRepLabel3->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
 

 Fl_Box *coreLabel = new Fl_Box(0,lp[5],80,16,"Display Intervall");
 coreLabel->labelsize(10);
 coreLabel->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 coreStart = new Fl_Input(84,lp[5],24,16);
 coreStart->textsize(10);

 Fl_Box *coreLabel2 = new Fl_Box(110,lp[5],8,16,"-");
 coreLabel2->labelsize(10);
 coreLabel2->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 coreEnd = new Fl_Input(120,lp[5],24,16);
 coreEnd->textsize(10);


 Fl_Box *defCategoryLabel = new Fl_Box(0,lp[6],80,16,"Default Category");
 defCategoryLabel->labelsize(10);
 defCategoryLabel->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 defCatMenu= new Fl_Menu_Button(84,lp[6],74,16);
 defCatMenu->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);
 defCatMenu->labelsize(10);
 prefFillCatMenu(NULL);


 Fl_Box *defLocationLabel = new Fl_Box(0,lp[7],80,16,"predef. Locations");
 defLocationLabel->labelsize(10);
 defLocationLabel->align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE);

 Fl_Button *defLocationButton  = new Fl_Button(84,lp[7],74,16,"Edit");
 defLocationButton->labelsize(10);
 defLocationButton->callback(editLocation);

 



 prefWin->end();
 prefWin->show();

 fillPrefWindow();
}


void prefFillCatMenu (Fl_Widget *w)
{
 int last=-1;
 int c=0;

 for(int i=0;i<MAX_CATEGORIES; i++) 
  if(categories[i]!=NULL)
   {
    defCatMenu->add(categories[i],0,(Fl_Callback *) prefSetCategory,(void *) i);
    defCatMenu->textsize(10);
    last=c;
    c++;
   }
 defCatMenu->mode(last,FL_MENU_DIVIDER  );
 defCatMenu->mode(last,FL_MENU_DIVIDER  );
 defCatMenu->add("Edit Categories",0,(Fl_Callback *) editCategories,(void *)prefFillCatMenu);
 defCatMenu->textsize(10);
 defCatMenu->redraw();

}


int curPrefCalType;
int curPrefLanguage;
int curPrefDefCat;


void fillPrefWindow()
{
 curPrefCalType  = defCalView;
 curPrefLanguage = language;
 curPrefDefCat               = defaultCat;

 prefFillCalType();
 

 switch (curPrefLanguage)
  {
  case LANG_DE: 
  case LANG_EN:
  default:
   languageMenu->label("en");
   break;
  }
 languageMenu->redraw();

 if(kernStart<0)
  kernStart =0;
 if(kernStart>22)
  kernStart =22;
 if(kernEnd<0)
  kernEnd =0;
 if(kernEnd>23)
  kernEnd   =23;

 sprintf(coreStartStr,"%d",kernStart);
 coreStart->value(coreStartStr);
 sprintf(coreEndStr,"%d",kernEnd);
 coreEnd->value(coreEndStr);


 if(alarmRepeat > 100)
  alarmRepeat =99;
 if(alarmRepeatIntervall > 10000)
  alarmRepeatIntervall =9999;

 sprintf(countStr,"%d",alarmRepeat);
 alarmRepCountInput->value(countStr);
 sprintf(intervallStr,"%d",alarmRepeatIntervall);
 alarmRepIntervallInput->value(intervallStr);

 defCatMenu->label(categories[curPrefDefCat]);
}


void exitPref(Fl_Widget *w)
{
 defCalView           = curPrefCalType;
 language             = curPrefLanguage;
 alarmRepeat          = atoi(alarmRepCountInput->value());
 alarmRepeatIntervall = atoi(alarmRepIntervallInput->value());
 kernStart            = atoi(coreStart->value());
 kernEnd              = atoi(coreEnd->value());
 defaultCat           = curPrefDefCat;

 savePrefs();

 closePref();
}
void cancelPref(Fl_Widget *w)
{
 // loadPrefs();
 closePref();
}
void closePref()
{
 prefWin->hide();
 delete prefWin;
 prefWin = NULL;
 buildCalendar();
}

void prefFillCalType()
{
 switch (curPrefCalType)
  {
  case MONTH_CAL:
   calType->label("Month Calendar");
   break;
  case WEEK_CAL: 
   calType->label("Week Calendar");
   break;
  case DAY_CAL:
  default:
   calType->label("Day Calendar");
   break;
  }
 calType->redraw();
}

void prefSetDayCal(Fl_Widget *w,void *)
{
 curPrefCalType = DAY_CAL;
}
void prefSetWeekCal(Fl_Widget *w,void *)
{
 curPrefCalType = WEEK_CAL;
}
void prefSetMonthCal(Fl_Widget *w,void *)
{
 curPrefCalType  = MONTH_CAL;
}
void prefSetCategory(Fl_Widget *w,void * cat)
{
 int l=(int ) cat;

 if(l >=0)
  {
   curPrefDefCat =l;
   printf("defCat =%d\n",curPrefDefCat);
   w->label(categories[l]);
  }
 w->redraw();
}
