/* File: timeDef.h
 *
 * Time-stamp: <18-May-2003 13:29:47 goetz>
 * $Id: $
 *
 * Copyright (C) 2003 by Rdiger Goetz
 *
 * Author: me
 *
 * Description: 
 * 
 */
# ifndef TIMEDEF_H_INCLUDED
# define TIMEDEF_H_INCLUDED


#ifdef ACAL_GUI_MAIN
int monLen[14]={0,31,28,31,30,31,30,31,31,30,31,30,31,0};
#else
extern int monLen[14];
#endif
class timeDef
{
public:
 int day;
 int mon;
 int year;
 int wday;
 int hour;
 int min;
 int sec;
 int tim;
 struct tm tm;

 timeDef ()
 {
  tim=0;
  day = 1;
  mon = 0;
  year= 1970;
  wday= 0;
  hour= 0;
  min = 0;
  sec = 0;
 }
 
 timeDef &operator= (timeDef s)
  {
   day = s.day ;
   mon = s.mon ;
   year= s.year;
   wday= s.wday;
   hour= s.hour;
   min = s.min ;
   sec = s.sec ;
   set();
   return *this;
  }
 timeDef &operator= (timeDef *s)
  {
   day = s->day ;
   mon = s->mon ;
   year= s->year;
   wday= s->wday;
   hour= s->hour;
   min = s->min ;
   sec = s->sec ;
   set(); 
   return *this;
  }


 void set (int t)
 {
  struct tm * tp;
  tim =t;
  tp = localtime((const time_t *) &t);
  day = tp->tm_mday;
  mon = tp->tm_mon+1;
  year= tp->tm_year +1900;
  wday= (tp->tm_wday+6) %7;
  hour= tp->tm_hour;
  min = tp->tm_min;
  sec = tp->tm_sec;
  memcpy(&tm,tp,sizeof(struct tm));
 }
 void set(int y, int m, int d, int h, int mi)
 {
  set(y,m,d,h,mi,0);
 }
 void set(int y, int m, int d, int h, int mi, int s)
 {
  day = d;  
  mon = m;
  year= y;
  hour= h;
  min = mi;
  sec = s;

  set();
 } 
 
 void set()
 {
  struct tm *tp;

  tm.tm_mday= day;
  tm.tm_mon = mon-1;
  tm.tm_year= year-1900;
  tm.tm_hour= hour;
  tm.tm_min = min;
  tm.tm_sec = sec;
  tim = mktime(&tm);

  tp = localtime((const time_t *) &tim);
  tm.tm_wday =  tp->tm_wday;
  wday = (tp->tm_wday +6) % 7;
 }


 void skip2NextDay()
 {
  day++;
  clipDateUpper();
 }
 void skip2NextWeek()
 {
  printf("next Week:  %d %d %d -> ",year,mon,day);
  day+=7;
  printf("%d %d %d \n",year,mon,day);
  clipDateUpper();
 }
 void skip2NextMonth()
 {
  mon++;
  clipDateUpper();
 }
 void skip2NextYear()
 {
  year++;
  clipDateUpper();
 }
 void skip2PrevDay()
 {
  day--;
  clipDateLower();
 }
 void skip2PrevWeek()
 {
  day-=7;
  clipDateLower();
 }
 void skip2PrevMonth()
 {
  mon--;
  clipDateLower();
 }
 void skip2PrevYear()
 {
  year--;
  clipDateLower();
 }

 
 void clipDateUpper()
 {
  //  printf("CLIP upper %d %d %d -> ",year,mon,day);
  if(mon == 2 && (year %4 ) == 0)
   {
    if( day > 29)
     {
      mon++;
      day = day -29;
     }
   }
  else
   if(day > monLen[mon])
    {
     day =day -monLen[mon];
     mon ++;
    }
  //  printf(" %d %d %d -> ",year,mon,day);

  if(mon > 12)
   {
    mon =1;
    year++;
   }
  //    printf(" %d %d %d \n",year,mon,day);
 }

 void clipDateLower()
 {
  if(day <1)
   {
    mon--;
    if(mon == 2 && (year %4 ) == 0)
     day = 29+day;
    else
     day =monLen[mon]+day;
   }
  if(mon<=0)
   {
    mon=12;
    year--;
    
   }
 }
 

 void beginningOfDay()
 {
  hour=0;
  min =0;
  sec =0;
  set();
 }
 void endOfDay()
 {
  hour=23;
  min =59;
  sec =59;
  set();
 }
 void beginningOfMonth()
 {
  day =1;
  hour=0;
  min =0;
  sec =0;
  set();
 }
 void endOfMonth()
 {
  day = monLen[mon];
  if(mon==2 && (year %4 ) == 0 )
   day++;
  hour=23;
  min =59;
  sec =59;
  set();
 }
 void print()
 {
  print(stdout);
 }
 void print(FILE *fp)
 {
  printf("tim=%8d <=> %2d.%2d.%4d, %2d:%02d:%02d  wday=%d\n",
	 tim,day,mon,year,hour,min,sec,wday);
 }
};


# endif
